C
C  BULLETIN7.FOR, Version 4/28/91
C  Purpose: Contains subroutines for the bulletin board utility program.
C  Environment: VAX/VMS
C  Usage: Invoked by the BULLETIN command.
C  Programmer: Mark R. London
C
C  Copyright (c) 1990
C  Property of Massachusetts Institute of Technology, Cambridge MA 02139.
C  This program cannot be copied or distributed in any form for non-MIT
C  use without specific written approval of MIT Plasma Fusion Center
C  Management.
C
	SUBROUTINE UPDATE_LOGIN(ADD_BULL)
C
C  SUBROUTINE UPDATE_LOGIN
C
C  FUNCTION:  Updates the login file when a bulletin has been deleted
C	or added.
C
	IMPLICIT INTEGER (A - Z)
 
	INCLUDE 'BULLDIR.INC'
 
	INCLUDE 'BULLUSER.INC'
 
	INCLUDE 'BULLFOLDER.INC'
 
	INCLUDE '($SSDEF)'
 
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 
	DIMENSION READ_BTIM_SAVE(2),TEMP_BTIM(2)
 
C
C  We want to keep the last read date for comparison when selecting new
C  folders, so save it for later restoring.
C
 
	READ_BTIM_SAVE(1) = READ_BTIM(1)
	READ_BTIM_SAVE(2) = READ_BTIM(2)
 
	CALL OPEN_BULLUSER_SHARED
 
C
C  Newest date/time in user file only applies to general bulletins.
C  This was present before adding folder capability.
C  We set flags in user entry to show new folder added for folder bulletins.
C  However, the newest bulletin for each folder is not continually updated,
C  As it is only used when comparing to the last bulletin read time, and to
C  store this for each folder would be too expensive.
C
 
	TEMP_BTIM(1) = NEWEST_BTIM(1)
	TEMP_BTIM(2) = NEWEST_BTIM(2)
	CALL READ_USER_FILE_HEADER(IER)
	NEWEST_BTIM(1) = TEMP_BTIM(1)
	NEWEST_BTIM(2) = TEMP_BTIM(2)
 
	IF (IER.NE.0) THEN
	   CALL CLOSE_BULLUSER
	   RETURN
	ELSE IF (FOLDER_NUMBER.EQ.0) THEN
	   CALL SYS_BINTIM(NEWEST_DATE//' '//NEWEST_TIME,NEWEST_BTIM)
	   REWRITE (4,IOSTAT=IER) USER_HEADER
	END IF
 
	BROAD_MSG = .FALSE.
	IF (ADD_BULL.AND.FOLDER_NUMBER.GE.0) THEN	! Message added?
	   IF (INCMD(1:3).NE.'ADD') THEN
	      BROAD_MSG = .TRUE.
	   ELSE IF (.NOT.CLI$PRESENT('BROADCAST')) THEN
	      BROAD_MSG = .TRUE.
	   END IF
	END IF
 
	IF (BROAD_MSG) THEN
	   IF (FOLDER_BBOARD(:2).NE.'::'.AND.
     &	       FOLDER_NUMBER.GT.0) THEN			! Folder private?
	      CALL CHKACL
     &		(FOLDER_FILE(1:TRIM(FOLDER_FILE))//'.BULLFIL',IER)
	      IF (IER.EQ.(SS$_ACLEMPTY.OR.SS$_NORMAL)) THEN
	         CHECK_ACL = 0
	      ELSE
	         CHECK_ACL = 1
	      END IF
	   ELSE
	       CHECK_ACL = 0
	   END IF
 
 	   CALL NOTIFY_USERS(CHECK_ACL)
	END IF
 
	CALL READ_USER_FILE_KEYNAME(USERNAME,IER)
		! Reobtain present values as calling programs still uses them
 
	READ_BTIM(1) = READ_BTIM_SAVE(1)
	READ_BTIM(2) = READ_BTIM_SAVE(2)
 
	CALL CLOSE_BULLUSER
 
	RETURN
 
	END
 
 
 
 
	SUBROUTINE NOTIFY_USERS(CHECK_ACL)
C
C  SUBROUTINE NOTIFY_USERS
C
C  FUNCTION: Notify users with SET NOTIFY set of new message.
C
	IMPLICIT INTEGER (A - Z)
	
	INCLUDE 'BULLUSER.INC'
 
	INCLUDE 'BULLDIR.INC'
 
	INCLUDE 'BULLFOLDER.INC'
 
	INCLUDE '($BRKDEF)'
 
	CHARACTER OUTPUT*160,TERMINAL*7,FLAGS*1
	CHARACTER*1 CR/13/,LF/10/,BELL/7/
	CHARACTER*12 SENT_TEMP_USER,TEMP_USERNAME
 
	OUTPUT = BELL//CR//LF//LF//
     &		'New bulletin added to folder '//FOLDER(1:TRIM(FOLDER))
     &		//'. From: '//FROM(1:TRIM(FROM))//CR//LF//
     &		'Description: '//DESCRIP(1:TRIM(DESCRIP))
 
	IER = SYS_TRNLNM('BULL_SYSTEM_FLAGS',FLAGS)
	IF (.NOT.IER) THEN
	   IER = SYS_TRNLNM('MAIL$SYSTEM_FLAGS',FLAGS)
	END IF
 
	BFLAG = 0
	READ (FLAGS(:1),'(I1)',IOSTAT=IER) FLAG
	IF (BTEST(FLAG,1).AND.IER.EQ.0) BFLAG = BRK$M_CLUSTER
 
	CALL SYS$SETRWM(%VAL(1))		! Don't wait if can't broadcast
 
	CALL INIT_QUEUE(TEMP_USER_QUEUE,TEMP_USERNAME)
	WRITE_TEMP_USER = TEMP_USER_QUEUE
 
	DO WHILE (GETUSERS(TEMP_USERNAME,TERMINAL))
	   READ_TEMP_USER = TEMP_USER_QUEUE
	   SENT_TEMP_USER = ' '
	   DO WHILE (TEMP_USERNAME.NE.SENT_TEMP_USER.AND.
     &				READ_TEMP_USER.NE.WRITE_TEMP_USER)
		 CALL READ_QUEUE(%VAL(READ_TEMP_USER),READ_TEMP_USER,
     &				SENT_TEMP_USER)
	   END DO
	   IF (TEMP_USERNAME.NE.SENT_TEMP_USER) THEN
	      CALL READ_USER_FILE_KEYNAME(TEMP_USERNAME,IER)
              CALL WRITE_QUEUE(%VAL(WRITE_TEMP_USER),WRITE_TEMP_USER,
     &				TEMP_USERNAME)
	   ELSE
	      IER = 2
	   END IF
	   IF (IER.EQ.0.AND.TEMP_USERNAME.NE.FROM.AND.
     &	       TEST2(NOTIFY_FLAG,FOLDER_NUMBER)) THEN
	      IF (CHECK_ACL) THEN
	         CALL CHECK_ACCESS
     &			(FOLDER_FILE(1:TRIM(FOLDER_FILE))//'.BULLFIL',
     &			TEMP_USERNAME,IER,WRITE_ACCESS)
	      ELSE
		 IER = 1
	      END IF
	      IF (IER) THEN
		 CALL SYS$BRKTHRU(,OUTPUT(1:TRIM(OUTPUT))//CR,
     &			TEMP_USERNAME(:TRIM(TEMP_USERNAME)),
     &			%VAL(BRK$C_USERNAME),,,%VAL(BFLAG),,,,)
	      ELSE
		 CALL CLR2(NOTIFY_FLAG,FOLDER_NUMBER)
	         REWRITE (4,IOSTAT=IER) TEMP_USERNAME//USER_ENTRY(13:)
	      END IF
	   END IF
	END DO
	CALL SYS$SETRWM(%VAL(0))
 
	RETURN
	END
 
 
 
 
 
	SUBROUTINE ADD_ENTRY
C
C  SUBROUTINE ADD_ENTRY
C
C  FUNCTION: Enters a new directory entry in the directory file.
C
	IMPLICIT INTEGER (A - Z)
	
	INCLUDE 'BULLDIR.INC'
 
	INCLUDE 'BULLFOLDER.INC'
 
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
	
	CHARACTER TODAY_TIME*32
 
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 
	IF (REMOTE_SET) THEN
	   LOCAL = .TRUE.
	   IF (INCMD(:3).EQ.'ADD') LOCAL = CLI$PRESENT('LOCAL')
	   IF (LOCAL) THEN
	      WRITE (REMOTE_UNIT,'(9A)',IOSTAT=IER)
     &			3,DESCRIP,EXDATE,EXTIME,SYSTEM,0,0,0,0
	   ELSE
	      WRITE (REMOTE_UNIT,'(9A)',IOSTAT=IER)
     &		3,DESCRIP,EXDATE,EXTIME,SYSTEM,CLI$PRESENT('BROADCAST'),
     &		CLI$PRESENT('BELL'),CLI$PRESENT('ALL'),
     &		CLI$PRESENT('CLUSTER')
	   END IF
	   IF (IER.EQ.0) THEN
	      READ(REMOTE_UNIT,'(Q,A)',IOSTAT=IER) I,FOLDER1_COM
	   END IF
	   IF (IER.EQ.0) THEN
	      IF (I.EQ.LEN(FOLDER1_COM)) THEN
	         IER = SYS$ASCTIM(,TODAY_TIME,F1_NEWEST_BTIM,)
	         NEWEST_DATE = TODAY_TIME(1:11)
	         NEWEST_TIME = TODAY_TIME(13:)
	         NBULL = F1_NBULL
		 CALL UPDATE_FOLDER
	      ELSE
		 WRITE (6,'(1X,A)') FOLDER1_COM(:I)
	      END IF
	   ELSE
	      CALL DISCONNECT_REMOTE
	      IF (INCMD(:4).EQ.'MOVE') CALL EXIT
	   END IF
	   CALL UPDATE_LOGIN(.TRUE.)
	   RETURN
	END IF
 
	NEW_DATE = .TRUE.
 
	GO TO 10
 
	ENTRY NEWS2BULL_ADD_ENTRY
 
	NEW_DATE = .FALSE.
 
10	CALL READDIR(0,IER)
 
	IF (IER.NE.1) THEN
	   NEWEST_EXDATE = '5-NOV-2000'
	   NEWEST_EXTIME = '00:00:00.00'
	   NEWEST_DATE = '5-NOV-1956'
	   NEWEST_TIME = '00:00:00.00'
	   NBULL = 0
	   NBLOCK = 0
	   SHUTDOWN = 0
	   NEMPTY = 0
	END IF
 
	IF (.NOT.NEW_DATE) THEN
	   DIFF = COMPARE_DATE(NEWEST_DATE,DATE)
	   IF (DIFF.EQ.0) THEN
	      DIFF = COMPARE_TIME(NEWEST_TIME,TIME)
	   END IF
	   IF (DIFF.GE.0) NEW_DATE = .TRUE.
	END IF
 
	IF (NEW_DATE) THEN
	   CALL SYS$ASCTIM(,TODAY_TIME,,)
	   DATE = TODAY_TIME(1:11)
	   TIME = TODAY_TIME(13:)
	END IF
	 
	NEWEST_DATE = DATE
	NEWEST_TIME = TIME
 
	DIFF = COMPARE_DATE(NEWEST_EXDATE,EXDATE)
	IF (DIFF.GT.0) THEN
	   NEWEST_EXDATE = EXDATE
	   NEWEST_EXTIME = EXTIME
	ELSE IF (DIFF.EQ.0) THEN
	   DIFF = COMPARE_TIME(NEWEST_EXTIME,EXTIME)
	   IF (DIFF.GT.0) NEWEST_EXTIME = EXTIME
	END IF
 
	NBULL = NBULL + 1
	BLOCK = NBLOCK + 1
	NBLOCK = NBLOCK + LENGTH
 
	IF ((SYSTEM.AND.4).EQ.4) THEN
	   SHUTDOWN = SHUTDOWN + 1
	   SHUTDOWN_DATE = DATE
	   SHUTDOWN_TIME = TIME
	END IF
 
	CALL UPDATE_LOGIN(.TRUE.)
 
	CALL WRITEDIR(NBULL,IER)
 
	CALL WRITEDIR(0,IER)
 
	RETURN
	END
 
 
 
 
	INTEGER FUNCTION COMPARE_BTIM(BTIM1,BTIM2)
C
C  FUNCTION COMPARE_BTIM
C
C  FUCTION: Compares times in binary format to see which is farther in future.
C
C  INPUTS:
C	BTIM1  -  First time in binary format
C	BTIM2  -  Second time in binary format
C  OUTPUT:
C	Returns +1 if first time is farther in future
C	Returns -1 if second time is farther in future
C	Returns 0 if equal timeb
Ct
	IMPLICIT INTEGER (A - Z) 
 l
	DIMENSION BTIM1(2),BTIM2(2),DIFF(2)
  
	CALL LIB$SUBX(BTIM1,BTIM2,DIFF)
 n
	IF (DIFF(2).LT.0) THEN.
	   COMPARE_BTIM = -1g
	ELSE IF (DIFF(2).GE.0) THEN
	   COMPARE_BTIM = +1o
	END IFo
  
	RETURN 
	END
 
  
 i
 r
 a
	INTEGER FUNCTION MINUTE_DIFF(DATE2,DATE1)
Co
C  FUNCTION MINUTE_DIFFt
Ce
C  FUNCTION: Finds difference in minutes between 2 binary times.
C
CS
	IMPLICIT INTEGER (A-Z)D
 L
	DIMENSION DATE1(2),DATE2(2)
 N
	CALL LIB$DAY(DAYS1,DATE1,MSECS1)i
	CALL LIB$DAY(DAYS2,DATE2,MSECS2)e
 
	MINUTE_DIFF = (DAYS2-DAYS1)*24*60 + (MSECS2-MSECS1)/6000E
 U
	RETURN'
	END
 C
 E
 U
 S
 I
 
	INTEGER FUNCTION COMPARE_DATE(DATE1,DATE2)E
C$
C  FUNCTION COMPARE_DATE
CD
C  FUCTION: Compares dates to see which is farther in future.V
C)
C  INPUTS:
C	DATE1  -  First date  (dd-mm-yy)
C	DATE2  -  Second date (If is equal to ' ', then use present date) 
C  OUTPUT:
C	Returns the difference in days between the two dates.
C	If the DATE1 is farther in the future, the output is positive,
C	else it is negative.
Cm
	IMPLICIT INTEGER (A - Z) 
 g
	CHARACTER*(*) DATE1,DATE2
	INTEGER USER_TIME(2)n
 o
	CALL SYS_BINTIM(DATE1,USER_TIME)n
 e
	CALL VERIFY_DATE(USER_TIME)
Cf
C  LIB$DAY crashes if date invalid, which happened once due to an unknownt
C  hardware or software error which created a date very far in the future.
Ci
	CALL LIB$DAY(DAY1,USER_TIME)t
  
	IF (DATE2.NE.' ') THENt
	   CALL SYS_BINTIM(DATE2,USER_TIME)
	   CALL VERIFY_DATE(USER_TIME) 
	ELSEB
	   CALL SYS$GETTIM(USER_TIME)
	END IF
 W
	CALL LIB$DAY(DAY2,USER_TIME)W
 _
	COMPARE_DATE = DAY1 - DAY2I
 I
	RETURNT
	END
  
 L
 O
	SUBROUTINE VERIFY_DATE(BTIM) 
 (
	IMPLICIT INTEGER (A-Z)
  
	DIMENSION BTIM(2),TEMP(2)
 '
	CALL SYS_BINTIM(' 5-NOV-2011 00:00:00.00',TEMP)
 )
	IER = COMPARE_BTIM(BTIM,TEMP)
 M
	IF (IER.GT.0) THEN		! Date invalidR
	   BTIM(1) = TEMP(1)s
	   BTIM(2) = TEMP(2)N
	END IFN
 A
	CALL SYS_BINTIM(' 5-NOV-1955 00:00:00.00',TEMP)
 .
	IER = COMPARE_BTIM(BTIM,TEMP)
 
	IF (IER.LT.0) THEN		! Date invalidF
	   BTIM(1) = TEMP(1)O
	   BTIM(2) = TEMP(2)O
	END IFR
 2
	RETURN.
	END
  
  
  
	INTEGER FUNCTION COMPARE_TIME(TIME1,TIME2)?
C 
C  FUNCTION COMPARE_TIME
CL
C  FUCTION: Compares times to see which is farther in future.E
CS
C  INPUTS:
C	TIME1  -  First time	(hh:mm:ss.xx)
C	TIME2  -  Second time 
C  OUTPUT:
C	Outputs (TIME1-TIME2) in seconds.  Thus, if TIME1 is further
C	in the future, outputs positive number, else negative.
C
 C
	IMPLICIT INTEGER (A-Z)E
	CHARACTER*(*) TIME1,TIME2
	CHARACTER*23 TODAY_TIME
	CHARACTER*11 TEMP2t
 
	IF (TIME2.EQ.' ') THEND
	   CALL SYS$ASCTIM(,TODAY_TIME,,)
	   TEMP2 = TODAY_TIME(13:)S
	ELSES
	   TEMP2 = TIME2
	END IF
 
	COMPARE_TIME = 3600*10*(ICHAR(TIME1(1:1))-ICHAR(TEMP2(1:1)))N
     &		         +3600*(ICHAR(TIME1(2:2))-ICHAR(TEMP2(2:2)))
     &		        +60*10*(ICHAR(TIME1(4:4))-ICHAR(TEMP2(4:4)))
     &		           +60*(ICHAR(TIME1(5:5))-ICHAR(TEMP2(5:5)))
     &		           +10*(ICHAR(TIME1(7:7))-ICHAR(TEMP2(7:7)))
     &		              +(ICHAR(TIME1(8:8))-ICHAR(TEMP2(8:8)))
 
	IF (COMPARE_TIME.EQ.0) THEN
	   COMPARE_TIME = 10*(ICHAR(TIME1(10:10))-ICHAR(TEMP2(10:10)))e
     &		            +(ICHAR(TIME1(11:11))-ICHAR(TEMP2(11:11)))
	   IF (COMPARE_TIME.GT.0) THEN/
	      COMPARE_TIME = 1/
	   ELSE IF (COMPARE_TIME.LT.0) THEN
	      COMPARE_TIME = -1
	   END IF
	END IFO
 E
	RETURN
	END
  
C-------------------------------------------------------------------------
C:
C  The following are subroutines to create a linked-list queue for B
C  temporary buffer storage of data that is read from files to beb
C  outputted to the terminal.  This is done so as to be able to closeT
C  the file as soon as possible.
CH
C  Each record in the queue has the following format.  The first two
C  words are used for creating a character variable.  The first word
C  contains the length of the character variable, the second containsE
C  the address.  The address is simply the address of the 3rd word ofR
C  the record.  The last word in the record contains the address of theL
C  next record.  Every time a record is written, if that record has aQ
C  zero link, it adds a new record for the next write operation. M
C  Therefore, there will always be an extra record in the queue.  To
C  check for the end of the queue, the last word (link to next record)
C  is checked to see if it is zero. 
C 
C-------------------------------------------------------------------------
	SUBROUTINE INIT_QUEUE(HEADER,DATA)C
	CHARACTER*(*) DATA	
	INTEGER HEADERE
	IF (HEADER.NE.0) RETURN		! Queue already initializedU
	LENGTH = LEN(DATA),
	IF (MOD(LENGTH,4).NE.0) LENGTH = LENGTH + 4 - MOD(LENGTH,4)
	CALL LIB$GET_VM(LENGTH+12,HEADER)
	CALL MAKE_CHAR(%VAL(HEADER),LEN(DATA),LENGTH)
	RETURN
	END
  
 R
	SUBROUTINE WRITE_QUEUE(RECORD,NEXT,DATA)Y
	INTEGER RECORD(1)
	CHARACTER*(*) DATAD
	LENGTH = RECORD(1)%
	CALL COPY_CHAR(LENGTH,DATA,%VAL(%LOC(RECORD)))
	IF (MOD(LENGTH,4).NE.0) LENGTH = LENGTH + 4 - MOD(LENGTH,4)
	NEXT = RECORD((LENGTH+12)/4) 
	IF (NEXT.NE.0) RETURN
	CALL LIB$GET_VM(LENGTH+12,NEXT)
	CALL MAKE_CHAR(%VAL(NEXT),RECORD(1),LENGTH)
	RECORD((LENGTH+12)/4) = NEXTR
	RETURND
	END
 E
	SUBROUTINE READ_QUEUE(RECORD,NEXT,DATA)
	CHARACTER*(*) DATAM
	INTEGER RECORD(1)
	LENGTH = RECORD(1)
	CALL COPY_CHAR(LENGTH,%VAL(%LOC(RECORD)),DATA) 
	IF (MOD(LENGTH,4).NE.0) LENGTH = LENGTH + 4 - MOD(LENGTH,4)
	NEXT = RECORD((LENGTH+12)/4)O
	RETURN(
	END
 A
	SUBROUTINE COPY_CHAR(LENGTH,INCHAR,OUTCHAR)
	CHARACTER*(*) INCHAR,OUTCHARI
	OUTCHAR = INCHAR(:LENGTH)
	RETURN 
	END
 E
	SUBROUTINE MAKE_CHAR(IARRAY,CHAR_LEN,REAL_LEN)'
	IMPLICIT INTEGER (A-Z)B
	DIMENSION IARRAY(1)
	IARRAY(1) = CHAR_LENN
	IARRAY(2) = %LOC(IARRAY(3))
	IARRAY(REAL_LEN/4+3) = 0R
	RETURNE
	END
 ,
 ,
 T
	SUBROUTINE DISABLE_PRIVS 
C 
C  SUBROUTINE DISABLE_PRIVS 
C 
C  FUNCTION: Disable image high privileges.E
C 
 $
	IMPLICIT INTEGER (A-Z)E
 B
	INCLUDE '($PRVDEF)'
 D
	COMMON /PRIVS/ SETPRV,PRV_DEPTH
	DIMENSION SETPRV(2)
 1
	DATA PRV_DEPTH /0/ 
 1
	COMMON /REALPROC/ REALPROCPRIV(2)
 E
	PRV_DEPTH = PRV_DEPTH + 1
 D
	IF (PRV_DEPTH.GT.1) RETURN
  
	CALL SYS$SETPRV(%VAL(0),,,SETPRV)	! Get privilegesD
 )
	SETPRV(1) = SETPRV(1).AND..NOT.REALPROCPRIV(1)T
 O
	CALL SYS$SETPRV(%VAL(0),SETPRV,,)	! Disable installed privs
 G
	RETURN
	END
 Y
 W
 U
	SUBROUTINE ENABLE_PRIVS
C 
C  SUBROUTINE ENABLE_PRIVS
C,
C  FUNCTION: Enable image high privileges.
CT
  
	IMPLICIT INTEGER (A-Z)E
 M
	COMMON /PRIVS/ SETPRV,PRV_DEPTH
	DIMENSION SETPRV(2)
 E
	PRV_DEPTH = PRV_DEPTH - 1
 B
	IF (PRV_DEPTH.GT.1) RETURN 
 T
	CALL SYS$SETPRV(%VAL(1),SETPRV,,)	! Enable image privsE
 H
	RETURNI
	END
 A
 D
 (
	SUBROUTINE CHECK_PRIV_IO(ERROR)
C)
C  SUBROUTINE CHECK_PRIV_IO_
CE
C  FUNCTION: Checks SYS$OUTPUT and SYS$ERROR to see if they need
C	privileges to output to.
C)
 E
	IMPLICIT INTEGER (A-Z)T
 Y
	CALL DISABLE_PRIVS			! Disable SYSPRV  
 I
	OPEN (UNIT=6,FILE='SYS$OUTPUT',IOSTAT=IER,STATUS='NEW')
	CLOSE (UNIT=6,STATUS='DELETE') 
 P
	OPEN (UNIT=4,FILE='SYS$ERROR',IOSTAT=IER1,STATUS='NEW')
	IF (IER.NE.0.OR.IER1.NE.0) THEN
	   IF (IER1.EQ.0) WRITE (4,100)
	   IF (IER.EQ.0) WRITE (6,200)M
	   ERROR = 1,
	ELSE
	   CLOSE (UNIT=4,STATUS='DELETE')
	   ERROR = 0I
	END IFN
 L
	CALL ENABLE_PRIVS			! Enable SYSPRV L
  
100	FORMAT(1X,'ERROR: SYS$OUTPUT cannot be opened.')
200	FORMAT(1X,'ERROR: SYS$ERROR cannot be opened.')A
 
	RETURNO
	END
  
 E
	SUBROUTINE CHANGE_FLAG(CMD,FLAG).
CE
C  SUBROUTINE CHANGE_FLAGL
CR
C  FUNCTION: Sets flags for specified folder.E
C
C  INPUTS:
C	CMD    -   LOGICAL*4 value. If TRUE, set flag. 
C		   If FALSE, clear flag.
C	FLAG	-  If 1, modify NEW_FLAG, if 2, modify SET_FLAG
C		   If 3, modify BRIEF_FLAG, 4, modify NOTIFY_FLAG
Cs
	IMPLICIT INTEGER (A - Z)	
 M
	INCLUDE 'BULLDIR.INC'
  
	INCLUDE 'BULLUSER.INC'u
  
	INCLUDE 'BULLFOLDER.INC' 
 f
	COMMON /BULL_NOTIFY/ NOTIFY_REMOTE(FLONG)
 i
	DIMENSION FLAGS(FLONG,4)u
	EQUIVALENCE (NEW_FLAG(1),FLAGS(1,1)) 
 l
	LOGICAL CMD
 1
	DIMENSION READ_BTIM_SAVE(2)
 I
	DATA CHANGE_FOLDER /.FALSE./I
 D
	IF (CLI$PRESENT('FOLDER')) THEN
	   IER = CLI$GET_VALUE('FOLDER',FOLDER1) 
	   IF (IER) THEN
	      FOLDER_NUMBER_SAVE = FOLDER_NUMBERr
	      CALL OPEN_BULLFOLDER_SHARED
	      CALL READ_FOLDER_FILE_KEYNAME_TEMP(FOLDER1,IER)
	      CALL CLOSE_BULLFOLDER
	      IF (IER.NE.0) THEN
	         WRITE (6,'('' ERROR: No such folder found.'')')A
	         RETURN
	      ELSE IF (INDEX(FOLDER1,'.').GT.0.OR.A
     &		 (FOLDER1(:1).GE.'a'.AND.FOLDER1(:1).LE.'z')) THEN
	         WRITE (6,'('' ERROR: Command not valid for folder.'')')
	         RETURN
	      END IFT
	   END IF
	   FOLDER_NUMBER = FOLDER1_NUMBER
	   CHANGE_FOLDER = .TRUE.
	ELSE IF (REMOTE_SET.EQ.3) THEN
	   WRITE (6,'('' ERROR: Command not valid for folder.'')')-
	   RETURN
	END IFe
 l
C 
C  Find user entry in BULLUSER.DAT to update information.f
Cn
 i
	ENTRY CHANGE_FLAG_NOCMD(CMD,FLAG)
 e
	CALL OPEN_BULLUSER_SHARED		! Open user file
 s
	READ_BTIM_SAVE(1) = READ_BTIM(1)
	READ_BTIM_SAVE(2) = READ_BTIM(2)A
 T
	CALL READ_USER_FILE_KEYNAME(USERNAME,IER)	! Read old entryT
 D
	IF (IER.GT.0) THEN 		! No entry (how did this happen??)
	   CALL SYS_BINTIM('-',LOGIN_BTIM)	! Get today's today 
	   CALL SYS_BINTIM('5-NOV-1956 11:05:56',READ_BTIM)	! Fake new entry 
	   CALL READ_USER_FILE_HEADER(IER)(
	   IF (CMD) THEN 
	      CALL SET2(FLAGS(1,FLAG),FOLDER_NUMBER)(
	   ELSE
	      CALL CLR2(FLAGS(1,FLAG),FOLDER_NUMBER)B
	   END IF
	   NEW_FLAG(1) = 143E
	   NEW_FLAG(2) = 0$
	   CALL WRITE_USER_FILE_NEW(IER)D
	ELSEA
	   IF (CMD) THENT
	      CALL SET2(FLAGS(1,FLAG),FOLDER_NUMBER)(
	   ELSE
	      CALL CLR2(FLAGS(1,FLAG),FOLDER_NUMBER)(
	   END IF
	   NEW_FLAG(1) = 1435
	   REWRITE (4,IOSTAT=IER) USER_ENTRY=
	   READ_BTIM(1) = READ_BTIM_SAVE(1)
	   READ_BTIM(2) = READ_BTIM_SAVE(2)
	END IFP
 s
	IF (CMD.AND.FLAG.EQ.4.AND.FOLDER_BBOARD(:2).EQ.'::') THEN
	   DO WHILE (REC_LOCK(IER))
	      READ (4,KEY='*NOTIFY',IOSTAT=IER) TEMP_USER,NOTIFY_REMOTE
	   END DO
  
	   IF (IER.NE.0) THEN
	      DO I=1,FLONGE
	         NOTIFY_REMOTE(I) = 0
	      END DOR
	      CALL SET2(NOTIFY_REMOTE,FOLDER_NUMBER)N
	      WRITE (4,IOSTAT=IER) '*NOTIFY     ',NOTIFY_REMOTE
	   ELSE
	      CALL SET2(NOTIFY_REMOTE,FOLDER_NUMBER) 
	      REWRITE (4,IOSTAT=IER) '*NOTIFY     ',NOTIFY_REMOTE
	   END IF
	END IFT
 2
	CALL CLOSE_BULLUSER
 I
	IF (CHANGE_FOLDER) THEN
	   FOLDER_NUMBER = FOLDER_NUMBER_SAVE
	   CHANGE_FOLDER = .FALSE.E
	END IFE
 C
	RETURN(
 T
	END
 2
 C
 A
 R
	SUBROUTINE SET_VERSIONR
C 
C  SUBROUTINE SET_VERSION 
CT
C  FUNCTION: Sets version number.M
C)
	IMPLICIT INTEGER (A - Z):
 
	INCLUDE 'BULLDIR.INC'
 
	INCLUDE 'BULLUSER.INC'M
  
	INCLUDE 'BULLFOLDER.INC'I
 R
	DIMENSION FLAGS(FLONG,4) 
	EQUIVALENCE (NEW_FLAG(1),FLAGS(1,1))P
 :
	LOGICAL CMD
  
	DIMENSION READ_BTIM_SAVE(2)
 A
CE
C  Find user entry in BULLUSER.DAT to update information.(
CP
 :
	CALL OPEN_BULLUSER_SHARED		! Open user file
 C
	READ_BTIM_SAVE(1) = READ_BTIM(1) 
	READ_BTIM_SAVE(2) = READ_BTIM(2)(
 )
	CALL READ_USER_FILE_KEYNAME(USERNAME,IER)	! Read old entryI
 R
	IF (IER.EQ.0) THENT
	   NEW_FLAG(1) = 143	
	   REWRITE (4,IOSTAT=IER) USER_ENTRY  ! Write modified entry(
	   READ_BTIM(1) = READ_BTIM_SAVE(1)
	   READ_BTIM(2) = READ_BTIM_SAVE(2)
	END IFH
 
	CALL CLOSE_FILE (4)
	RETURNN
 F
	END
 O
 E
 R
 R
 
	SUBROUTINE CHECK_NEWUSER(USERNAME,DISMAIL,PASSCHANGE)
C-
C  SUBROUTINE CHECK_NEWUSER
CT
C  FUNCTION: Checks flags for a new: Whether DISMAIL is set,
C		and what the last password change was.t
C 
C  INPUTS:
C	USERNAME  -  Usernamet
C  OUTPUTS:l
C  	DISMAIL     -  Returns 1 if account has DISMAIL.
C		       returns 0 if account has no DISMAIL.
C	PASSCHANGE  -  Date of last password change.
C 
 r
	IMPLICIT INTEGER (A-Z)a
 a
	CHARACTER*(*) USERNAMEs
 o
	INTEGER PASSCHANGE(2)
 o
	INCLUDE '($UAIDEF)'
  
	CALL INIT_ITMLSTE
	CALL ADD_2_ITMLST(4,UAI$_FLAGS,%LOC(FLAGS))
	CALL ADD_2_ITMLST(8,UAI$_PWD_DATE,%LOC(PASSCHANGE))
	CALL END_ITMLST(GETUAI_ITMLST)d
 s
	DISMAIL = 0					! Set return false 
	IER = SYS$GETUAI(,,USERNAME,%VAL(GETUAI_ITMLST),,,)	! Read Record
	IF (IER) THEN					! If username found
	   IF (BTEST(FLAGS,UAI$V_NOMAIL)) THEN		! DISMAIL SET? 
	      DISMAIL = 1				! Yept
	   END IF
	END IFt
 l
	RETURN						! Returnr
	END						! Endc
  
 s
 i
	INTEGER FUNCTION SYS_TRNLNM(INPUT,OUTPUT)
 -
	IMPLICIT INTEGER (A-Z)-
 -
	CHARACTER*(*) INPUT,OUTPUT 
 T
        PARAMETER LNM$_STRING = '2'X
 	
	CALL INIT_ITMLST	! Initialize item list
	IF (OUTPUT.NE.'DEFINED') CALL ADD_2_ITMLST_WITH_RET
     &		(LEN(OUTPUT),LNM$_STRING,%LOC(OUTPUT),%LOC(OLEN)),
	CALL END_ITMLST(TRNLNM_ITMLST)	! Get address of itemlistL
 A
	SYS_TRNLNM = SYS$TRNLNM(,'LNM$FILE_DEV',INPUT(:TRIM(INPUT)),,
     &		%VAL(TRNLNM_ITMLST))
 G
	IF (SYS_TRNLNM.AND.OUTPUT.NE.'DEFINED') OUTPUT = OUTPUT(:OLEN)O
 C
	RETURNH
	END
 L
 O
 E
 D
	INTEGER FUNCTION SYS_TRNLNM_SYSTEM(INPUT,OUTPUT)-
 D
	IMPLICIT INTEGER (A-Z)D
 E
	CHARACTER*(*) INPUT,OUTPUT 
 U
        PARAMETER LNM$_STRING = '2'X
 L
	CALL INIT_ITMLST	! Initialize item list
	IF (OUTPUT.NE.'DEFINED') CALL ADD_2_ITMLST_WITH_RET
     &		(LEN(OUTPUT),LNM$_STRING,%LOC(OUTPUT),%LOC(OLEN))M
	CALL END_ITMLST(TRNLNM_ITMLST)	! Get address of itemlist(
 G
	SYS_TRNLNM_SYSTEM = SYS$TRNLNM(,'LNM$SYSTEM',
     &		INPUT(:TRIM(INPUT)),,%VAL(TRNLNM_ITMLST)) 
 O
	IF (SYS_TRNLNM_SYSTEM.AND.OUTPUT.NE.'DEFINED') THEN
	   OUTPUT = OUTPUT(:OLEN)
	END IFA
 R
	RETURNA
	END
 I
 O
 H
	INTEGER FUNCTION FILE_LOCK(IER,IER1)E
 S
	IMPLICIT INTEGER (A-Z)Y
 A
	INCLUDE '($RMSDEF)'
 I
	DATA INIT /.TRUE./M
 I
	IF (INIT) THENR
	   FILE_LOCK = 1
	   INIT = .FALSE.
	ELSE)
	   IF (IER.GT.0) THEN
	      CALL ERRSNS(IDUMMY,IER1)
	      IF (IER1.EQ.RMS$_FLK) THENS
	         FILE_LOCK = 1
		 CALL WAIT_SEC('01')
	      ELSEr
	         FILE_LOCK = 0I
	         INIT = .TRUE.I
	      END IFF
	   ELSE
	      FILE_LOCK = 0
	      IER1 = 0I
	      INIT = .TRUE.
	   END IF
	END IF
 M
	RETURNP
	END
 P
 P
 (
	SUBROUTINE ENABLE_CTRLD
 H
	IMPLICIT INTEGER (A-Z)G
 )
	COMMON /CTRLY/ CTRLY$
 P
	COMMON /CTRL_LEVEL/ LEVEL
 i
	COMMON /DEF_PROT/ ORIGINAL_DEF_PROT
 O
        COMMON /KEYPAD/ KEYPAD_MODEP
 %
	QUIT = 1R
 )
	ENTRY ENABLE_CTRL_EXITs
 G
	QUIT = QUIT.AND.1		! If called via entry, QUIT = 0S
	IF (QUIT.EQ.1) LEVEL = LEVEL - 1,
  
	IF (LEVEL.LT.0.AND.QUIT.EQ.1) THENe
	   WRITE (6,'('' ERROR: Error in CTRL.'')')
	END IFS
 E
	IF (LEVEL.EQ.0.OR.QUIT.EQ.0) THEN
	   CALL LIB$ENABLE_CTRL(CTRLY,)	! Enable CTRL-Y & -C.
	END IF 
 T
	IF (QUIT.EQ.0) THEN
	   IF (KEYPAD_MODE.EQ.0) THEN
	      IER = SMG$CREATE_VIRTUAL_KEYBOARD(KEYBOARD_ID,,,,)V
	      IER = SMG$SET_KEYPAD_MODE(KEYBOARD_ID,1)
	   END IF
	   CALL UPDATE_USERINFO
	   CALL SYS$SETDFPROT(ORIGINAL_DEF_PROT,)
	   CALL EXIT
	END IFI
	QUIT = 0			! Reinitialize
 I
	RETURNV
	END
 a
  
	SUBROUTINE DISABLE_CTRL
 I
	IMPLICIT INTEGER (A-Z)R
 A
	COMMON /CTRLY/ CTRLYT
 S
	COMMON /CTRL_LEVEL/ LEVEL
	DATA LEVEL /0/$
 O
	IF (LEVEL.EQ.0) CALL LIB$DISABLE_CTRL(CTRLY,)
	LEVEL = LEVEL + 1
 (
	RETURN)
	END
 ,
 )
  
 F
	SUBROUTINE CLEANUP_BULLFILE
CR
C  SUBROUTINE CLEANUP_BULLFILE
C,
C  FUNCTION:  Searches for empty space in bulletin file and deletes it.a
C 
	IMPLICIT INTEGER (A - Z),
 R
	INCLUDE 'BULLFILES.INC'
 e
	INCLUDE 'BULLDIR.INC'
  
	INCLUDE 'BULLFOLDER.INC''
 
	CHARACTER FILENAME*132,BUFFER*128
  
	CALL OPEN_BULLDIR_SHARED
 S
CO
C  NOTE: Can't use READDIR for reading header since it'll spawn a 
C  BULL/CLEANUP.  (Fooey).
C 
 G
	DO WHILE (REC_LOCK(IER))f
	   READ (2,KEYID=0,KEY=HEADER_KEY,IOSTAT=IER) BULLDIR_HEADERW
	END DO 
 m
	IF (NEMPTY.EQ.0) THEN		! No cleanup necessary
	 CALL CLOSE_BULLDIR
	 RETURN
	ELSE IF (NEMPTY.GT.0) THENC
 E
	 CALL SYS$SETDFPROT('FF00'X,CUR_DEF_PROT)
		! Set protection to (SYSTEM:RWED,OWNER:RWED,,)
 O
	 OPEN (UNIT=11,FILE=FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPFIL',
     1	      STATUS='UNKNOWN',IOSTAT=IER,DISPOSE='DELETE',
     1	      RECORDTYPE='FIXED',RECORDSIZE=32,
     1	      FORM='UNFORMATTED',INITIALSIZE=((NBLOCK-NEMPTY)*128)/512)
				! Compressed version is number 1
 
	 IF (IER.NE.0) THEN
	    WRITE (6,'('' Cannot open temporary file for''H
     &		,'' compressing '',A)') FOLDER(:TRIM(FOLDER)),
	    CALL ERRSNS(IDUMMY,IER)
	    IF (IER1.EQ.0) THEN
	       WRITE (6,'('' IOSTAT error = '',I)') IER
	    ELSE'
	       CALL SYS_GETMSG(IER1)E
	    END IF(
	    CALL CLOSE_BULLDIR 
	    CALL SYS$SETDFPROT(CUR_DEF_PROT,)
	 END IF
 H
	 CALL COPY_ACL(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.BULLFIL',
     &		       FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPFIL')
 D
	 CALL OPEN_BULLFIL_SHARED		! Open bulletin file
 .
	 NBLOCK = 0
 E
	 DO I=1,NBULL				! Copy bulletins to new file
	   CALL READDIR(I,IER)'
	   ICOUNT = BLOCK
	   DO J=1,LENGTHF
	      NBLOCK = NBLOCK + 1
	      DO WHILE (REC_LOCK(IER1))
	         READ(1'ICOUNT,IOSTAT=IER1) BUFFERL
	      END DO_
	      IF (IER1.NE.0) THEN		! This file is corrupt
		 NBLOCK = NBLOCK - 1
		 NBULL = I - 1
	         GO TO 100D
	      END IFA
	      WRITE(11) BUFFERl
	      ICOUNT = ICOUNT + 1
	   END DO
	 END DO
 i
100	 CALL CLOSE_BULLFILL
	ELSE IF (NEMPTY.EQ.-1) THEN
	 CALL CLOSE_BULLDIR
	 CALL OPEN_BULLDIR	! Open with no sharing
	 IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPFIL',F
     &				'*.BULLFIL')
	 IER = 1S
	 DO WHILE (IER)
	    IER = LIB$DELETE_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//
     &				'.BULLFIL;-1')
	 END DO
	 IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPDIR',
     &				'*.BULLDIR')
	 CALL CLOSE_BULLDIR_DELETEL
	 IER = 1(
	 DO WHILE (IER)
	    IER = LIB$DELETE_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//
     &				'.BULLDIR;-1')
	 END DO
	 IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.BULL*',
     &				'*.*;1')
	 RETURN
	END IFs
 I
	OPEN (UNIT=12,FILE=FOLDER_FILE(1:TRIM(FOLDER_FILE))
     &	      //'.TMPDIR',STATUS='UNKNOWN',FORM='UNFORMATTED',I
     &	      RECORDTYPE='FIXED',RECORDSIZE=DIR_RECORD_LENGTH/4,E
     &	      ORGANIZATION='INDEXED',IOSTAT=IER,DISPOSE='DELETE',
     &	      KEY=(9:12:INTEGER,1:8:CHARACTER),ACCESS='KEYED', 
     &	      INITIALSIZE=(((NBULL+1)*DIR_RECORD_LENGTH)/512)+1 )
  
	IF (IER.NE.0) THENE
	   OPEN (UNIT=12,FILE=FOLDER_FILE(1:TRIM(FOLDER_FILE))I
     &	      //'.TMPDIR',STATUS='UNKNOWN',FORM='UNFORMATTED',U
     &	      RECORDTYPE='FIXED',RECORDSIZE=DIR_RECORD_LENGTH/4,N
     &	      ORGANIZATION='INDEXED',IOSTAT=IER,DISPOSE='DELETE',
     &	      KEY=(9:12:INTEGER,1:8:CHARACTER),ACCESS='KEYED')O
	    IF (IER.NE.0) THEN 
	       CLOSE (UNIT=11)u
	       CALL CLOSE_BULLDIR
	       CALL SYS$SETDFPROT(CUR_DEF_PROT,)
	       RETURN
	    END IF
	END IF'
 L
	CALL COPY_ACL(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.BULLDIR',E
     &		       FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPDIR')
 T
	NEMPTY = 0A
	WRITE (12,IOSTAT=IER) BULLDIR_HEADER	! Write directory header
 P
	NBLOCK = 0		! Update directory entry pointers
	DO I=1,NBULLT
	   CALL READDIR(I,IER) 
	   BLOCK = NBLOCK + 1
	   CALL GET_MSGKEY(MSG_BTIM,MSG_KEY)K
	   WRITE (12,IOSTAT=IER) BULLDIR_ENTRYR
	   NBLOCK = NBLOCK + LENGTH
	END DO 
 4
	CLOSE (UNIT=12,STATUS='KEEP')
	CLOSE (UNIT=11,STATUS='KEEP')
 
	CALL CLOSE_BULLDIRA
	CALL OPEN_BULLDIR	! Open with no sharingM
 V
	NEMPTY = -1		! Copying done, indicate that in case of crash
	WRITE (2,IOSTAT=IER) BULLDIR_HEADER ! Write new directory headerC
 G
	IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPFIL',
     &				'*.BULLFIL')
	IER = 1
	DO WHILE (IER) 
	   IER = LIB$DELETE_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//e
     &				'.BULLFIL;-1')
	END DO 
	IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.TMPDIR',
     &				'*.BULLDIR')
	CALL CLOSE_BULLDIR_DELETE
	IER = 1
	DO WHILE (IER)P
	   IER = LIB$DELETE_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//G
     &				'.BULLDIR;-1')
	END DOA
	IER = LIB$RENAME_FILE(FOLDER_FILE(:TRIM(FOLDER_FILE))//'.BULL*',C
     &				'*.*;1')
 T
	CALL SYS$SETDFPROT(CUR_DEF_PROT,)
 
	RETURN_
	END
 T
 _
 L
 d
	SUBROUTINE CLEANUP_DIRFILE(DELETE_ENTRY)
CR
C  SUBROUTINE CLEANUP_DIRFILEE
CI
C  FUNCTION:  Reorder directory file after deletions.r
C	      Is called either directly after a deletion, or isA
C	      called if it is detected that a deletion was not fully
C	      completed due to the fact that the deleting processG
C	      was abnormally terminated.
C-
	IMPLICIT INTEGER (A - Z)
 
	INCLUDE 'BULLFILES.INC'
 
	INCLUDE 'BULLDIR.INC'
 S
	CHARACTER*(DIR_RECORD_LENGTH) BULLDIR_ENTRY_SAVEe
 i
	CHARACTER*11 DATE_SAVE,EXDATE_SAVED
	CHARACTER*11 TIME_SAVE,EXTIME_SAVEU
 L
	BULLDIR_ENTRY_SAVE = BULLDIR_ENTRY
	DATE_SAVE = DATEN
	TIME_SAVE = TIMEd
	EXDATE_SAVE = EXDATE
	EXTIME_SAVE = EXTIMEM
 L
	NBULL = -NBULL		! Negative # Bulls signals deletion in progress
	MOVE_TO = 0		! Moving directory entries starting here
	MOVE_FROM = 0		! Moving directory entries from here
	I = DELETE_ENTRY	! Start search point for first deleted entries
	DO WHILE (MOVE_TO.EQ.0.AND.I.LE.NBULL)U
	   CALL READDIR(I,IER) 
	   IF (IER.NE.I+1) THEN	! Have we found a deleted entry? 
	      MOVE_TO = I	! If so, start moving entries to here
	      J=I+1		! Search for next entry in file,
	      DO WHILE (MOVE_FROM.EQ.0.AND.J.LE.NBULL)e
		 CALL READDIR(J,IER)
		 IF (IER.EQ.J+1) MOVE_FROM = J
		 J = J + 1
	      END DOU
	      IF (MOVE_FROM.EQ.0) THEN	! There are no more entriesY
		 NBULL = I - 1		! so just update number of bulletins
		 CALL WRITEDIR(0,IER)T
		 RETURN
	      END IFT
	      LENGTH = -LENGTH		! Indicate starting point by writingY
	      CALL WRITEDIR(I,IER)	! next entry into deleted entry 
	      FIRST_DELETE = I		! with negative lengthS
	      MOVE_FROM = MOVE_FROM + 1	! Set up pointers to move rest of
	      MOVE_TO = MOVE_TO + 1	! the entries
	   ELSE IF (LENGTH.LT.0) THEN	! If negative length found, deletionI
	      FIRST_DELETE = I		! was previously in progress
	      J = I			! Try to find where entry came from
	      CALL INIT_QUEUE(ENTRY_Q1,BULLDIR_ENTRY)
	      ENTRY_Q = ENTRY_Q1S
	      DO K=J,NBULLD
		 CALL READDIR(K,IER)
	         IF (IER.EQ.K+1) THEN
		    CALL WRITE_QUEUE(%VAL(ENTRY_Q),ENTRY_Q,BULLDIR_ENTRY)I
		 END IFR
	      END DO 
	      ENTRY_QLAST = ENTRY_Q
	      ENTRY_Q2 = ENTRY_Q1
	      DO WHILE (MOVE_FROM.EQ.0.AND.ENTRY_Q2.NE.ENTRY_QLAST)
		 CALL READ_QUEUE(%VAL(ENTRY_Q2),ENTRY_Q,BULLDIR_ENTRY)
		 ENTRY_Q2 = ENTRY_Q.
		 BLOCK_SAVE = BLOCK'
		 MSG_NUM_SAVE = MSG_NUM)
		 DO WHILE (MOVE_FROM.EQ.0.AND.ENTRY_Q.NE.ENTRY_QLAST) 
						! Search for duplicate entries
		    CALL READ_QUEUE(%VAL(ENTRY_Q),ENTRY_Q,BULLDIR_ENTRY)
		    IF (BLOCK_SAVE.EQ.BLOCK) THENG
		       MOVE_TO = MSG_NUM_SAVE + 1,
		       MOVE_FROM = MSG_NUM + 1
		    END IF
		 END DO 
		 			! If no duplicate entry found for this
					! entry, see if one exists for anyE
	      END DO			! of the other entries
	   END IF
	   I = I + 1
	END DOO
 N
	IF (I.LE.NBULL) THEN		! Move reset of entries if necessaryR
	   IF (MOVE_FROM.GT.0) THEN
	      DO J=MOVE_FROM,NBULL$
	         CALL READDIR(J,IER)$
		 IF (IER.EQ.J+1) THEN	! Skip any other deleted entries
		    CALL WRITEDIR(MOVE_TO,IER)
		    MOVE_TO = MOVE_TO + 1T
		 END IF_
	      END DO 
	   END IF
	   DO J=MOVE_TO,NBULL		! Delete empty records at end of file
	      CALL READDIR(J,IER)
	      DELETE(UNIT=2,IOSTAT=IER)
	   END DO
	   NBULL = MOVE_TO - 1		! Update # bulletin count
	END IFL
 M
	CALL READDIR(FIRST_DELETE,IER)B
	IF (IER.EQ.FIRST_DELETE+1.AND.LENGTH.LT.0) THEN
	   LENGTH = -LENGTH		! Fix entry which has negative lengthF
	   CALL WRITEDIR(FIRST_DELETE,IER)E
	END IF 
 D
	CALL WRITEDIR(0,IER)K
 I
	BULLDIR_ENTRY = BULLDIR_ENTRY_SAVE
	DATE = DATE_SAVE0
	TIME = TIME_SAVEp
	EXDATE = EXDATE_SAVEE
	EXTIME = EXTIME_SAVES
 F
	RETURNG
	END
 C
 E
	SUBROUTINE SHOW_FLAGS
C0
C  SUBROUTINE SHOW_FLAGS
Ct
C  FUNCTION: Show user flags.E
C)
	IMPLICIT INTEGER (A - Z)F
 E
	INCLUDE 'BULLDIR.INC'
 /
	INCLUDE 'BULLUSER.INC'S
 U
	INCLUDE 'BULLFOLDER.INC'O
 '
	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT
 E
C,
C  Find user entry in BULLUSER.DAT to obtain flags.K
CM
	IF (REMOTE_SET.NE.3) THEN
	   CALL OPEN_BULLUSER_SHARED		! Open user fileN
	   CALL READ_USER_FILE_KEYNAME(USERNAME,IER)	! Read old entry
	ELSE IF (NEWS_FIND_SUBSCRIBE().GT.FOLDER_MAX) THENC
	   WRITE (6,'('' ERROR: NEWS FOLDER is not subscribed.'')')
           RETURNr
 	END IF
 I
	WRITE (6,'('' For the selected folder '',A)')
     &	   FOLDER_NAME(1:TRIM(FOLDER_NAME))
	L
	IF (REMOTE_SET.NE.3.AND.TEST2(NOTIFY_FLAG,FOLDER_NUMBER)) THEND
	   WRITE (6,'('' NOTIFY is set.'')'),
	END IF	
  
	IF (TEST_SET_FLAG(FOLDER_NUMBER).AND.
     &	   (.NOT.TEST_BRIEF_FLAG(FOLDER_NUMBER))) THEN 
	   WRITE (6,'('' READNEW is set.'')')
	ELSE IF (TEST_BRIEF_FLAG(FOLDER_NUMBER).AND.A
     &	       TEST_SET_FLAG(FOLDER_NUMBER)) THEN
	   WRITE (6,'('' BRIEF is set.'')')
	ELSE IF (TEST_BRIEF_FLAG(FOLDER_NUMBER).AND.O
     &	       .NOT.TEST_SET_FLAG(FOLDER_NUMBER)) THENR
	   WRITE (6,'('' SHOWNEW is set.'')')
	ELSE IF (REMOTE_SET.EQ.3.OR.=
     &		.NOT.TEST2(NOTIFY_FLAG,FOLDER_NUMBER)) THENW
	   WRITE (6,'('' No flags are set.'')')
	END IFN
 O
	IF (REMOTE_SET.NE.3) CALL CLOSE_BULLUSERE
  
	RETURNY
	END
 H
 
	SUBROUTINE SET2(FLAG,NUMBER)E
 U
	IMPLICIT INTEGER (A-Z)i
 
	INTEGER FLAG(2)
 L
	F_POINT = NUMBER/32 + 1
	FLAG(F_POINT) = IBSET(FLAG(F_POINT),NUMBER-32*(F_POINT-1))O
 I
	RETURN
	END
 =
 B
	SUBROUTINE CLR2(FLAG,NUMBER)F
 E
	IMPLICIT INTEGER (A-Z)U
 I
	INTEGER FLAG(3)
 E
	F_POINT = NUMBER/32 + 1
	FLAG(F_POINT) = IBCLR(FLAG(F_POINT),NUMBER-32*(F_POINT-1)))
  
	RETURNE
	END
 D
 T
 
	LOGICAL FUNCTION TEST2(FLAG,NUMBER)
 L
	IMPLICIT INTEGER (A-Z)E
 R
	INTEGER FLAG(3)
  
	F_POINT = NUMBER/32 + 1
	TEST2 = BTEST(FLAG(F_POINT),NUMBER-32*(F_POINT-1))D
 F
	RETURNB
	END
  
 &
 	
 *
	INTEGER FUNCTION GETUSERS(USERNAME,TERMINAL)L
CO
C  FUNCTION GETUSERS
CI
C  FUNCTION:
C	To get names of all users that are logged in.E
CI
  
	IMPLICIT INTEGER (A-Z)X
 ,
	INCLUDE '($JPIDEF)'
 G
!*** MODULE $PSCANDEF ***Z
	PARAMETER pscan$_BEGIN = '00000000'XE
	PARAMETER pscan$_ACCOUNT = '00000001'XC
	PARAMETER pscan$_AUTHPRI = '00000002'XI
	PARAMETER pscan$_CURPRIV = '00000003'X/
	PARAMETER pscan$_GRP = '00000004'X 
	PARAMETER pscan$_HW_MODEL = '00000005'X
	PARAMETER pscan$_HW_NAME = '00000006'XA
	PARAMETER pscan$_JOBPRCCNT = '00000007'X 
	PARAMETER pscan$_JOBTYPE = '00000008'XC
	PARAMETER pscan$_MASTER_PID = '00000009'X
	PARAMETER pscan$_MEM = '0000000A'X
	PARAMETER pscan$_MODE = '0000000B'X
	PARAMETER pscan$_NODE_CSID = '0000000C'X)
	PARAMETER pscan$_NODENAME = '0000000D'X	A
	PARAMETER pscan$_OWNER = '0000000E'XF
	PARAMETER pscan$_PRCCNT = '0000000F'X
	PARAMETER pscan$_PRCNAM = '00000010'X
	PARAMETER pscan$_PRI = '00000011'XU
	PARAMETER pscan$_PRIB = '00000012'X
	PARAMETER pscan$_STATE = '00000013'XM
	PARAMETER pscan$_STS = '00000014'XD
	PARAMETER pscan$_TERMINAL = '00000015'X
	PARAMETER pscan$_UIC = '00000016'Xo
	PARAMETER pscan$_USERNAME = '00000017'X
	PARAMETER pscan$_GETJPI_BUFFER_SIZE = '00000018'X
	PARAMETER pscan$_END = '00000019'XT
	PARAMETER pscan$k_type = '00000081'XL
	PARAMETER pscan$M_OR = '00000001'XN
	PARAMETER pscan$M_BIT_ALL = '00000002'X
	PARAMETER pscan$M_BIT_ANY = '00000004'X
	PARAMETER pscan$M_GEQ = '00000008'X
	PARAMETER pscan$M_GTR = '00000010'X
	PARAMETER pscan$M_LEQ = '00000020'X
	PARAMETER pscan$M_LSS = '00000040'X
	PARAMETER pscan$M_PREFIX_MATCH = '00000080'XE
	PARAMETER pscan$M_WILDCARD = '00000100'X,
	PARAMETER pscan$M_CASE_BLIND = '00000200'X 
	PARAMETER pscan$M_EQL = '00000400'X
	PARAMETER pscan$M_NEQ = '00000800'X
	STRUCTURE /item_specific_flags/
	    PARAMETER pscan$S_OR = 1:
	    PARAMETER pscan$V_OR = 0
	    PARAMETER pscan$S_BIT_ALL = 1
	    PARAMETER pscan$V_BIT_ALL = 1
	    PARAMETER pscan$S_BIT_ANY = 1
	    PARAMETER pscan$V_BIT_ANY = 2
	    PARAMETER pscan$S_GEQ = 1
	    PARAMETER pscan$V_GEQ = 3
	    PARAMETER pscan$S_GTR = 1
	    PARAMETER pscan$V_GTR = 4
	    PARAMETER pscan$S_LEQ = 1
	    PARAMETER pscan$V_LEQ = 5
	    PARAMETER pscan$S_LSS = 1
	    PARAMETER pscan$V_LSS = 6
	    PARAMETER pscan$S_PREFIX_MATCH = 1e
	    PARAMETER pscan$V_PREFIX_MATCH = 7	
	    PARAMETER pscan$S_WILDCARD = 1 
	    PARAMETER pscan$V_WILDCARD = 8 
	    PARAMETER pscan$S_CASE_BLIND = 1f
	    PARAMETER pscan$V_CASE_BLIND = 9 
	    PARAMETER pscan$S_EQL = 1
	    PARAMETER pscan$V_EQL = 10-
	    PARAMETER pscan$S_NEQ = 1
	    PARAMETER pscan$V_NEQ = 11I
	BYTE %FILL (2)N
	END STRUCTURE
 (
	CHARACTER USERNAME*(*),TERMINAL*(*)
 i
	DATA CONTEXT/0/
 S
	IF (CONTEXT.EQ.0) THEN 
	   CALL INIT_ITMLST	! Initialize item listT
				! Now add items to listT
	   CALL ADD_2_ITMLST_WITH_RET(0,PSCAN$_NODE_CSID,0,PSCAN$M_NEQ)
	   CALL ADD_2_ITMLST(0,PSCAN$_MODE,JPI$K_INTERACTIVE)
	   CALL END_ITMLST(PSCAN_ITMLST)	! Get address of itemlisto
 e
	   IER = SYS$PROCESS_SCAN(CONTEXT,%VAL(PSCAN_ITMLST))
	END IFf
  
	CALL INIT_ITMLST	! Initialize item list
				! Now add items to list
	CALL ADD_2_ITMLST(LEN(USERNAME),JPI$_USERNAME,%LOC(USERNAME))
	CALL ADD_2_ITMLST(LEN(TERMINAL),JPI$_TERMINAL,%LOC(TERMINAL))
	CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist 
  
	IER = 1
	TERMINAL(1:1) = CHAR(0)
	DO WHILE (IER.AND.TERMINAL(1:1).EQ.CHAR(0))
						! Get next interactive process
	   IER = SYS$GETJPIW(,CONTEXT,,%VAL(GETJPI_ITMLST),,,,)
						! Get next process.)
	END DOh
  
	IF (.NOT.IER) CONTEXT = 0
 =
	GETUSERS = IER 
 a
	RETURN 
	END
 i
 
 C
  
 T
	SUBROUTINE OPEN_USERINFO 
C 
C  SUBROUTINE OPEN_USERINFON
C	
C  FUNCTION:  Opens the file in SYS$LOGIN which contains user information.
Cy
	IMPLICIT INTEGER (A - Z) 
 R
	INCLUDE 'BULLUSER.INC'a
 e
	COMMON /USERINFO/ USERINFO_READ,OLD_LAST_READ_BTIM(2,FOLDER_MAX)e
	COMMON /USERINFO/ OLD_LAST_SYS_BTIM(2,FOLDER_MAX)
	COMMON /USERINFO/ OLD_LAST_NEWS_READ(2,FOLDER_MAX) 
	DATA USERINFO_READ /.FALSE./D
 T
	EQUIVALENCE (LAST_READ_BTIM(1,1),LAST(1,1))
	DIMENSION LAST(2,FOLDER_MAX)y
 m
	INTEGER TODAY_BTIM(2)
 E
	CALL OPEN_BULLINF_SHARED
  
	READ (9,KEY=USERNAME,IOSTAT=IER) USERNAME,LASTC
  
	IF (IER.EQ.0) THEN		! Check to see if dates all in future
	   CALL SYS_BINTIM('-',TODAY_BTIM)	! Get today's date
	   DO I=1,FOLDER_MAX 
	      DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,I),TODAY_BTIM)
	      IF (DIFF.GE.0) THEN	! Must have been in a time wrap
		 LAST_READ_BTIM(1,I) = TODAY_BTIM(1)
		 LAST_READ_BTIM(2,I) = TODAY_BTIM(2)
	      END IF 
	   END DO
	END IFV
  
	IF (IER.NE.0.AND.TEST_BULLCP().EQ.2	! Is this BULLCP process?
     &	    .AND.CONFIRM_USER(USERNAME).NE.0) THEN	! Not real user?
	   USERNAME = 'DECNET'_
	   READ (9,KEY=USERNAME,IOSTAT=IER) USERNAME,LAST
	END IFO
 M
	IF (IER.NE.0) THEN 
	   OPEN (UNIT=10,FILE='SYS$LOGIN:BULLETIN.INF',STATUS='OLD', 
     &	      RECORDTYPE='FIXED',FORM='UNFORMATTED',IOSTAT=IER)
	   INQUIRE(UNIT=10,RECORDSIZE=INF_SIZE)
	   IF (IER.EQ.0) THEN
	      READ (10)
     &	  ((LAST_READ_BTIM(1,I),LAST_READ_BTIM(2,I)),I=1,INF_SIZE/2)s
	      CLOSE (UNIT=10,STATUS='DELETE')
	   ELSE
	      CALL OPEN_BULLUSER_SHARED		! Get BULLUSER.DAT fileE
	      CALL READ_USER_FILE_KEYNAME(USERNAME,IER)  ! Find user's info
	      CALL CLOSE_BULLUSER
	      IF (IER.NE.0.AND.TEST_BULLCP().EQ.2) THEN	! BULLCP process?
	         CALL SYS_BINTIM('-',LOGIN_BTIM)	! Get today's date
	         CALL SYS_BINTIM('5-NOV-1956 11:05:56',READ_BTIM)
		 CALL READ_USER_FILE_HEADER(IER)
		 NEW_FLAG(1) = 143
		 NEW_FLAG(2) = 0
	         CALL WRITE_USER_FILE_NEW(IER)E
	      END IFT
	      IF (IER.EQ.0) THEN-
	         DO I=1,FOLDER_MAX 
	            LAST_READ_BTIM(1,I) = READ_BTIM(1)I
	            LAST_READ_BTIM(2,I) = READ_BTIM(2)B
	         END DO
	      END IF
	   END IF
	   IF (IER.EQ.0) WRITE (9,IOSTAT=IER) USERNAME,LAST
	END IF 
 I
	LU = TRIM(USERNAME)
	USERNAME(LU:LU) = CHAR(128.OR.ICHAR(USERNAME(LU:LU)))
	READ (9,KEY=USERNAME,IOSTAT=IER1) USERNAME,LAST_SYS_BTIMI
	USERNAME(LU:LU) = CHAR(127.AND.ICHAR(USERNAME(LU:LU)))C
	IF (IER1.NE.0) THEN
	   DO I=1,FOLDER_MAXR
	      LAST_SYS_BTIM(1,I) = 0D
	      LAST_SYS_BTIM(2,I) = 0
	   END DO
	END IFy
  
	USERNAME(LU:LU) = CHAR(128.OR.ICHAR(USERNAME(LU:LU)))
	IF (LU.GT.1) THEN
	   USERNAME(LU-1:LU-1) = CHAR(128.OR.ICHAR(USERNAME(LU-1:LU-1)))M
	ELSEA
	   USERNAME(2:2) = CHAR(128.OR.ICHAR(USERNAME(2:2)))(
	END IFE
	READ (9,KEY=USERNAME,IOSTAT=IER1) USERNAME,LAST_NEWS_READ
	USERNAME(LU:LU) = CHAR(127.AND.ICHAR(USERNAME(LU:LU)))(
	IF (LU.GT.1) THEN
	   USERNAME(LU-1:LU-1) = CHAR(127.AND.ICHAR(USERNAME(LU-1:LU-1)))
	ELSEM
	   USERNAME(2:2) = CHAR(127.AND.ICHAR(USERNAME(2:2)))
	END IFT
	IF (IER1.NE.0) THEN
	   DO I=1,FOLDER_MAX
	      LAST_NEWS_READ(1,I) = 0
	      LAST_NEWS_READ(2,I) = 0
	   END DO
	END IF)
 T
	CALL CLOSE_BULLINF'
 E
	CALL LIB$MOVC3(FOLDER_MAX*2*4,LAST_READ_BTIM,OLD_LAST_READ_BTIM)
	CALL LIB$MOVC3(FOLDER_MAX*2*4,LAST_SYS_BTIM,OLD_LAST_SYS_BTIM)'
	CALL LIB$MOVC3(FOLDER_MAX*2*4,LAST_NEWS_READ,OLD_LAST_NEWS_READ)O
  
	USERINFO_READ = .TRUE._
 G
	RETURNU
	END
 E
 
  
	SUBROUTINE UPDATE_USERINFO'
C)
C  SUBROUTINE UPDATE_USERINFO=
C 
C  FUNCTION:  Updates the latest message read times for each folder.
Cf
	IMPLICIT INTEGER (A - Z)N
 O
	INCLUDE 'BULLUSER.INC'A
 C
	COMMON /USERINFO/ USERINFO_READ,OLD_LAST_READ_BTIM(2,FOLDER_MAX)U
	COMMON /USERINFO/ OLD_LAST_SYS_BTIM(2,FOLDER_MAX)
	COMMON /USERINFO/ OLD_LAST_NEWS_READ(2,FOLDER_MAX)=
 S
	EQUIVALENCE (LAST_READ_BTIM(1,1),LAST(1,1))
	DIMENSION LAST(2,FOLDER_MAX)T
  
	IF (.NOT.USERINFO_READ) RETURN 
 E
	DIFF = .FALSE.I
	FNUM = 1(
 
	DO WHILE (.NOT.DIFF.AND.FNUM.LE.FOLDER_MAX)
	   DIFF = LAST_READ_BTIM(1,FNUM).NE.OLD_LAST_READ_BTIM(1,FNUM)
	   IF (.NOT.DIFF) THENT
	      DIFF = LAST_READ_BTIM(2,FNUM).NE.OLD_LAST_READ_BTIM(2,FNUM)
	   END IF
	   FNUM = FNUM + 1+
	END DO2
 B
	DIFF1 = .FALSE.
	FNUM = 1(
 O
	DO WHILE (.NOT.DIFF1.AND.FNUM.LE.FOLDER_MAX)I
	   DIFF1 = LAST_SYS_BTIM(1,FNUM).NE.OLD_LAST_SYS_BTIM(1,FNUM)
	   IF (.NOT.DIFF1) THEN
	      DIFF1 = LAST_SYS_BTIM(2,FNUM).NE.OLD_LAST_SYS_BTIM(2,FNUM) 
	   END IF
	   FNUM = FNUM + 1P
	END DOG
 *
	DIFF2 = .FALSE.
	FNUM = 1R
 T
	DO WHILE (.NOT.DIFF2.AND.FNUM.LE.FOLDER_MAX)n
	   DIFF2 = LAST_NEWS_READ(1,FNUM).NE.OLD_LAST_NEWS_READ(1,FNUM)
	   IF (.NOT.DIFF2) THEN
	      DIFF2 = LAST_NEWS_READ(2,FNUM).NE.OLD_LAST_NEWS_READ(2,FNUM)c
	   END IF
	   FNUM = FNUM + 1M
	END DOn
 W
	IF (.NOT.(DIFF.OR.DIFF1.OR.DIFF2)) RETURN
 N
	CALL OPEN_BULLINF_SHAREDR
 c
	IF (DIFF) THEN0
	   READ (9,KEY=USERNAME,IOSTAT=IER)
	   IF (IER.EQ.0) REWRITE (9,IOSTAT=IER) USERNAME,LAST
	END IFp
 n
	IF (DIFF1) THEN
	   LU = TRIM(USERNAME)E
	   USERNAME(LU:LU) = CHAR(128.OR.ICHAR(USERNAME(LU:LU)))D
	   READ (9,KEY=USERNAME,IOSTAT=IER)
	   IF (IER.EQ.0) THEN
	      REWRITE (9,IOSTAT=IER) USERNAME,LAST_SYS_BTIM
	   ELSE
	      WRITE (9,IOSTAT=IER) USERNAME,LAST_SYS_BTIM
	   END IF
	   USERNAME(LU:LU) = CHAR(127.AND.ICHAR(USERNAME(LU:LU)))
	END IF_
  
	IF (DIFF2) THEN
	   LU = TRIM(USERNAME)=
	   USERNAME(LU:LU) = CHAR(128.OR.ICHAR(USERNAME(LU:LU)))T
	   IF (LU.GT.1) THEN0
	      USERNAME(LU-1:LU-1) = CHAR(128.OR.ICHAR(USERNAME(LU-1:LU-1)))
	   ELSE
	      USERNAME(2:2) = CHAR(128.OR.ICHAR(USERNAME(2:2)))
	   END IF
	   READ (9,KEY=USERNAME,IOSTAT=IER)
	   IF (IER.EQ.0) THEN
	      REWRITE (9,IOSTAT=IER) USERNAME,LAST_NEWS_READM
	   ELSE
	      WRITE (9,IOSTAT=IER) USERNAME,LAST_NEWS_READ0
	   END IF
	   IF (LU.GT.1) THEN0
	      USERNAME(LU-1:LU-1) = CHAR(127.AND.ICHAR(USERNAME(LU-1:LU-1)))_
	   ELSE
	      USERNAME(2:2) = CHAR(127.AND.ICHAR(USERNAME(2:2)))R
	   END IF
	END IFL
  
	CALL CLOSE_BULLINFM
 R
	RETURNE
	END
 0
 0
	INTEGER FUNCTION SYS_BINTIM(TIME,BTIM)
 R
	IMPLICIT INTEGER (A-Z)g
 
	INTEGER BTIM(2)
 S
	CHARACTER*(*) TIMET
 p
	IF (TRIM(TIME).EQ.20) THENR
	   SYS_BINTIM = SYS$BINTIM(TIME//'.00',BTIM)T
	ELSE1
	   SYS_BINTIM = SYS$BINTIM(TIME,BTIM)
	END IFT
 p
	RETURNT
	END
 
  
 R
 T
	SUBROUTINE NEW_MESSAGE_NOTIFICATION
CV
C  SUBROUTINE NEW_MESSAGE_NOTIFICATION
C 
C  FUNCTION:
Cn
C  Update user's last read bulletin date.  If new bulletins have been=
C  added since the last time bulletins have been read, position bulletin
C  pointer so that next bulletin read is the first new bulletin, and
C  alert user.  If READNEW set and no new bulletins, just exit.n
CW
 C
	IMPLICIT INTEGER (A-Z)p
 n
	INCLUDE 'BULLFOLDER.INC'R
 T
	INCLUDE 'BULLUSER.INC' 
  
	COMMON /READIT/ READIT=
 
	COMMON /POINT/ BULL_POINT
 -
	COMMON /SYSTEM_FOLDERS/ SYSTEM_FLAG(FLONG),DUMMY(2)
 N
	COMMON /SHUTDOWN/ NODE_NUMBER,NODE_AREA
	COMMON /SHUTDOWN/ SHUTDOWN_FLAG(FLONG))
 i
	COMMON /COMMAND_SWITCHES/ LOGIN_SWITCH,SYSTEM_SWITCHA
	COMMON /COMMAND_SWITCHES/ SYSTEM_LOGIN_BTIM(2) 
	COMMON /COMMAND_SWITCHES/ REVERSE_SWITCH,SEPARATE
	CHARACTER*1 SEPARATEA
 _
	COMMON /SAVE_FOLDERS/ SAVE_FOLDER_Q1,SAVE_FOLDER_NUMT
 )
	COMMON /LOGIN_BTIM/ LOGIN_BTIM_SAVE(2) 
 r
	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD
 T
	IF (INCMD(:4).EQ.'SHOW') THEN
	   CALL READ_IN_FOLDERS			! Read folder info	
	ELSE IF (.NOT.LOGIN_SWITCH) THEND
	   LOGIN_BTIM_SAVE(1) = LOGIN_BTIM(1)
	   LOGIN_BTIM_SAVE(2) = LOGIN_BTIM(2)
	   CALL UPDATE_READ(0)			! Update login timeN
	   IF (CLI$PRESENT('SELECT_FOLDER')) THEN
	      CALL SELECT_FOLDER(.TRUE.,IER)C
	      IF (IER) RETURN
	   END IF
	   CALL READ_IN_FOLDERS			! Read folder infop
	ELSE
	   LOGIN_SWITCH = .FALSE.		! So LOGIN_FOLDER entry doesn't	
	END IF					! think it's called via LOGIN.
 .
	FOLDER_Q = SAVE_FOLDER_Q1
  
	DO I = 1,SAVE_FOLDER_NUM
	   CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)B
	   CALL CLR2(NEW_MSG,FOLDER_NUMBER)	! Clear new message flag$
	   IF (.NOT.TEST_BULLCP().AND.NODE_AREA.GT.0.AND.READIT.EQ.1A
     &	       .AND.TEST2(SHUTDOWN_FLAG,FOLDER_NUMBER)) THENU
	      CALL SET2(NEW_MSG,FOLDER_NUMBER)M
	   ELSE IF (TEST2(SET_FLAG,FOLDER_NUMBER).OR.
     &		TEST2(BRIEF_FLAG,FOLDER_NUMBER).OR.A
     &		(FOLDER_NUMBER.GT.0.AND.
     &		TEST2(SYSTEM_FLAG,FOLDER_NUMBER).AND.READIT.EQ.1)) THEN
	      IF (READIT.EQ.1.AND.SYSTEM_SWITCH.AND.D
     &		TEST2(SYSTEM_FLAG,FOLDER_NUMBER)) THEN
	         DIFF = COMPARE_BTIM(SYSTEM_LOGIN_BTIM,
     &					F_NEWEST_BTIM)C
	      ELSEf
	         DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &					F_NEWEST_BTIM)E
		 IF (DIFF.LT.0.AND.READIT.EQ.1) THEN
		    IF (.NOT.TEST2(BRIEF_FLAG,FOLDER_NUMBER).OR.
     &			.NOT.TEST2(SET_FLAG,FOLDER_NUMBER).OR.B
     &			NEW_FLAG(2).NE.-1) THEN
	               DIFF = COMPARE_BTIM(LOGIN_BTIM_SAVE,F_NEWEST_BTIM)
		    END IF
		    IF (FOLDER_BBOARD(:2).EQ.'::'.AND.DIFF.GE.0) THEN 
			IER = MINUTE_DIFF(LOGIN_BTIM_SAVE,F_NEWEST_BTIM) 
			IF (IER.LE.15) DIFF = -1E
		    END IF
		 END IFS
	      END IFE
	      IF (F_NBULL.GT.0.AND.(DIFF.LT.0.OR.(READIT.EQ.1.AND.N
     &		  BTEST(FOLDER_FLAG,7)))) THEN	    ! If new unread messagesR
		 CALL SET2(NEW_MSG,FOLDER_NUMBER)   ! Set new message flag
	      END IFI
	   END IF
	END DO(
 .
	FOLDER_Q = SAVE_FOLDER_Q1
  
	IF (READIT.EQ.0) THEN 			! If not in READNEW mode
	   CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM) 
	   NEW_MESS = .FALSE.
	   DO I = 1,SAVE_FOLDER_NUM-1
	      CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)
	      IF (TEST2(NEW_MSG,FOLDER_NUMBER)) THENR
		 DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1), 
     &					F_NEWEST_BTIM)S
		 IF (DIFF.LT.0) THEN		! Are there unread messages?
		    DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &					F_NEWEST_NOSYS_BTIM)A
		    IF (DIFF.GT.0) THEN		! Unread non-system messages?
	               DIFF = COMPARE_BTIM(LOGIN_BTIM,F_NEWEST_BTIM) 
						! No. Unread system messages? 
		       IF (DIFF.GT.0) THEN	! No, update last read time.D
			  LAST_READ_BTIM(1,FOLDER_NUMBER+1) =
     &						F_NEWEST_BTIM(1)
			  LAST_READ_BTIM(2,FOLDER_NUMBER+1) =
     &						F_NEWEST_BTIM(2)
		       END IF)
		    END IF
		    IF (DIFF.LT.0) THENE
		       WRITE (6,'('' There are new messages in '',
     &			   ''folder '',A,''.'',$)') FOLDER(1:TRIM(FOLDER))S
		       NEW_MESS = .TRUE.
		    END IF
		 END IFL
	      END IF 
	   END DO
	   CALL NEWS_NEW_NOTIFICATION(NEWS_MESS)
	   IF (INCMD(:4).EQ.'SHOW') THENM
	      SAVE_FOLDER_Q1 = 0R
	      RETURN)
	   END IF
	   IF (NEW_MESS.OR.NEWS_MESS) THEN 
	      WRITE (6,'('' Type SELECT followed by foldername to'',2
     &			 '' read above messages.'')')
	   END IF
	   SAVE_FOLDER_Q1 = 0
	   FOLDER_NUMBER = 0T
	   CALL SELECT_FOLDER(.FALSE.,IER)2
	   DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &				F_NEWEST_BTIM)
	   IF (DIFF.LT.0.AND.F_NBULL.GT.0) THEN
	      CALL FIND_NEWEST_BULL	! See if there are new messages
	      IF (BULL_POINT.NE.-1) THEN1
	        WRITE(6,'('' Type READ to read new GENERAL messages.'')')
		NEW_COUNT = F_NBULL - BULL_POINT
		DIG = 0_
		DO WHILE (NEW_COUNT.GT.0)(
		   NEW_COUNT = NEW_COUNT / 10_
		   DIG = DIG + 1
		END DO
		WRITE(6,'('' There are '',I<DIG>,'' new messages.'')')
     &			F_NBULL - BULL_POINT	! Alert user if new bulletinsO
	      ELSEF
	        BULL_POINT = 0T
	        LAST_READ_BTIM(1,FOLDER_NUMBER+1) = F_NEWEST_BTIM(1)B
	        LAST_READ_BTIM(2,FOLDER_NUMBER+1) = F_NEWEST_BTIM(2)m
	      END IFe
	   END IF
	ELSE				! READNEW mode.
	   DO I = 1,SAVE_FOLDER_NUM
	      CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)
	      IF (TEST2(NEW_MSG,FOLDER_NUMBER)) THEND
		 CALL SELECT_FOLDER(.FALSE.,IER)
		 IF (IER) THEN
	           IF (SYSTEM_SWITCH.AND.
     &		        TEST2(SYSTEM_FLAG,FOLDER_NUMBER)) THEN
	            DIFF = COMPARE_BTIM(SYSTEM_LOGIN_BTIM,F_NEWEST_BTIM) 
		   ELSE
		    DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &					F_NEWEST_BTIM),
		    IF (BTEST(FOLDER_FLAG,7)) DIFF = -1F
		    IF (DIFF.LT.0.AND.TEST2(BRIEF_FLAG,FOLDER_NUMBER)N
     &		       .AND.TEST2(SET_FLAG,FOLDER_NUMBER)) THEN 
		       IF (DIFF.LT.0) THEN
		        IF (FOLDER_NUMBER.GT.0) CALL LOGIN_FOLDERM
	                IF (BULL_POINT.NE.-1.OR.NEW_FLAG(2).EQ.-1.OR.
     &			   .NOT.TEST2(SYSTEM_FLAG,FOLDER_NUMBER))
     &		        WRITE (6,'('' There are new messages in folder '' 
     &			  ,A,''.'')') FOLDER(1:TRIM(FOLDER))=
		       ELSE 
		        WRITE (6,'('' There are new messages in folder '' 
     &			  ,A,''.'')') FOLDER(1:TRIM(FOLDER))_
		       END IF 
		       DIFF = 0N
		    END IF
		   END IFR
		   IF (DIFF.LT.0) THEN
		    IF (FOLDER_NUMBER.GT.0) CALL LOGIN_FOLDERM
	            IF (BULL_POINT.NE.-1) THENO
		     IF (.NOT.TEST2(BRIEF_FLAG,FOLDER_NUMBER)) THENI
		       SAVE_BULL_POINT = BULL_POINTE
		       REDO = .TRUE.
		       DO WHILE (REDO)
		          REDO = .FALSE.
		          CALL READNEW(REDO)
			  IF (REDO) CALL REDISPLAY_DIRECTORYH
			  BULL_POINT = SAVE_BULL_POINT
		       END DOS
		     END IFE
		    END IF
		   END IF
		 END IFI
	      END IFR
	   END DO
	   CALL NEWS_NEW_NOTIFICATION(NEWS_MESS)T
	   CALL EXITE
	END IF_
 M
	RETURN 
	END
 S
 A
 L
 U
	SUBROUTINE READ_IN_FOLDERSM
 U
	IMPLICIT INTEGER (A-Z) 
 F
	INCLUDE 'BULLFOLDER.INC'R
 E
	INCLUDE 'BULLUSER.INC' 
 R
	COMMON /SAVE_FOLDERS/ SAVE_FOLDER_Q1,SAVE_FOLDER_NUM0
	DATA SAVE_FOLDER_Q1/0/-
 =
	COMMON /READIT/ READITM
 U
	COMMON /SYSTEM_FOLDERS/ SYSTEM_FLAG(FLONG),DUMMY(2)
 I
	COMMON /SHUTDOWN/ NODE_NUMBER,NODE_AREA
	COMMON /SHUTDOWN/ SHUTDOWN_FLAG(FLONG).
 0
	CALL INIT_QUEUE(SAVE_FOLDER_Q1,FOLDER_COM)E
	FOLDER_Q = SAVE_FOLDER_Q1
  
	CALL OPEN_BULLFOLDER_SHARED		! Go find folders
  
	SAVE_FOLDER_NUM = 0
 T
	FOLDER_NUMBER = 0
	CALL READ_FOLDER_FILE_KEYNUM(FOLDER_NUMBER,IER)
	DO WHILE (IER.EQ.0)
	   SAVE_FOLDER_NUM = SAVE_FOLDER_NUM + 1A
	   IF (.NOT.TEST_BULLCP().AND.NODE_AREA.GT.0.AND.READIT.EQ.1
     &	       .AND.TEST2(SHUTDOWN_FLAG,FOLDER_NUMBER)) THENM
	   ELSE IF ((NEW_FLAG(1).LT.142.OR.NEW_FLAG(1).GT.143).AND.
     &	      TEST2(BRIEF_FLAG,FOLDER_NUMBER).AND.R
     &	      .NOT.TEST2(SET_FLAG,FOLDER_NUMBER)) THEN1
	      CALL CHANGE_FLAG_NOCMD(0,3)
	      CALL SET_VERSIONR
	   ELSE IF (TEST2(SET_FLAG,FOLDER_NUMBER).OR.
     &		TEST2(BRIEF_FLAG,FOLDER_NUMBER).OR._
     &		(FOLDER_NUMBER.GT.0.AND.(BTEST(FOLDER_FLAG,2).OR.e
     &		TEST2(SYSTEM_FLAG,FOLDER_NUMBER)).AND.READIT.EQ.1)) THEN
Cs
C  Unknown problem caused system folder flag in folder file to disappear
C  so this tests to see if the flag has disappeared and resets if needed.s
Ca
	      IF (TEST2(SYSTEM_FLAG,FOLDER_NUMBER).AND.
     &		  .NOT.BTEST(FOLDER_FLAG,2)) THENI
		 FOLDER_FLAG = IBSET(FOLDER_FLAG,2)
	         CALL REWRITE_FOLDER_FILE
	      ELSE IF (.NOT.TEST2(SYSTEM_FLAG,FOLDER_NUMBER).AND.
     &		  BTEST(FOLDER_FLAG,2)) THEN
		 CALL MODIFY_SYSTEM_LIST(1)M
	      END IFS
	   END IF
	   CALL WRITE_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)
	   CALL READ_FOLDER_FILE_KEYNUM_GT(FOLDER_NUMBER,IER)
	END DOM
  
	CALL CLOSE_BULLFOLDER
 S
	FOLDER_Q = SAVE_FOLDER_Q1
	CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)
 E
	RETURNU
	END
 C
 O
 L
 N
	SUBROUTINE DISCONNECT_REMOTE
 M
	IMPLICIT INTEGER (A-Z)
 A
	INCLUDE 'BULLFOLDER.INC'I
 D
	WRITE (6,'('' ERROR: Connection to remote folder disconnected.'')')
 S
	FOLDER_NUMBER = -1C
	FOLDER1 = 'GENERAL'
 S
	CALL SELECT_FOLDER(.FALSE.,IER)
 M
	WRITE (6,'('' Resetting to GENERAL folder.'')')
  
	RETURNg
	END
