C
C  BULLETIN.FOR, Version 1/9/93
C  Purpose: Bulletin board utility program.
C  Environment: VAX/VMS
C  Usage: Invoked by the BULLETIN command.
C  Programmer: Mark R. London
C
	IMPLICIT INTEGER (A - Z)

	INCLUDE 'BULLFILES.INC'

	INCLUDE 'BULLDIR.INC'

	INCLUDE 'BULLFOLDER.INC'

	INCLUDE 'BULLUSER.INC'

	INCLUDE '($RMSDEF)'

	COMMON /BULLPAR/ BULL_PARAMETER,LEN_P
	CHARACTER*64 BULL_PARAMETER

	COMMON /POINT/ BULL_POINT

	COMMON /READIT/ READIT

	COMMON /PAGE/ PAGE_LENGTH,PAGE_WIDTH,PAGING
	LOGICAL PAGING /.FALSE./

	COMMON /CTRLY/ CTRLY

	COMMON /PROMPT/ COMMAND_PROMPT
	CHARACTER*40 COMMAND_PROMPT

	COMMON /ACCESS/ READ_ONLY
	LOGICAL READ_ONLY

	COMMON /DECNET/ DECNET_PROC,ERROR_UNIT
	LOGICAL DECNET_PROC

	EXTERNAL ERROR_TRAP
	EXTERNAL BULLETIN_SUBCOMMANDS,LIB$GET_INPUT
	EXTERNAL BULLETIN_MAINCOMMANDS,ENABLE_CTRL_EXIT
	EXTERNAL CLI$_ABSENT,CLI$_NOCOMD,CLI$_NEGATED

	PARAMETER PCB$M_BATCH = '4000'X
	PARAMETER PCB$M_NETWRK = '200000'X
	PARAMETER LIB$M_CLI_CTRLY = '2000000'X

	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD

	CHARACTER HELP_DIRECTORY*64,SAVE_FOLDER*44

	COMMON /EDIT/ EDIT_DEFAULT
	DATA EDIT_DEFAULT/.FALSE./

	COMMON /COMMAND_SWITCHES/ LOGIN_SWITCH,SYSTEM_SWITCH
	COMMON /COMMAND_SWITCHES/ SYSTEM_LOGIN_BTIM(2)
	COMMON /COMMAND_SWITCHES/ REVERSE_SWITCH,SEPARATE
	CHARACTER*4 SEPARATE

	COMMON /TAGS/ BULL_TAG,READ_TAG

	COMMON /DEF_PROT/ ORIGINAL_DEF_PROT

	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT

	COMMON /PROMPT_PROMPT/ PROMPT,LPROMPT
	CHARACTER*44 PROMPT

	COMMON /BULL_CUSTOM/ BULL_CUSTOM

	COMMON /SAVE_FOLDERS/ SAVE_FOLDER_Q1,SAVE_FOLDER_NUM

	CHARACTER DCL_CMD*132

	IER = SYS_TRNLNM_SYSTEM('BULL_CUSTOM',BULL_PARAMETER)	
	IF (IER) IER = OTS$CVT_TZ_L(BULL_PARAMETER(:TRIM(BULL_PARAMETER))
     &		,BULL_CUSTOM,,,%VAL(1)) 

	CALL LIB$GET_FOREIGN(INCMD)
	DCL_COMMAND = INDEX(INCMD,' "').GT.0.OR.INCMD(:1).EQ.'"'

	CALL LIB$ESTABLISH(ERROR_TRAP)
        IF (.NOT.CLI$GET_VALUE('PROMPT',COMMAND_PROMPT,ILEN)) THEN
           CALL LIB$REVERT
           CALL CLI$GET_VALUE('$LINE',COMMAND_PROMPT,ILEN)
	   INCMD = 'BULLETIN '//INCMD
           CALL CLI$DCL_PARSE(INCMD,BULLETIN_MAINCOMMANDS)
        ELSE
           CALL LIB$REVERT
        END IF

	IF (DCL_COMMAND) THEN
	   IER = CLI$GET_VALUE('SELECT_FOLDER',DCL_CMD,LENP)
	   IF (LENP.GT.0) THEN
	      IF (DCL_CMD(LENP:LENP).EQ.'"') DCL_CMD = DCL_CMD(:LENP-1)
	      IF (DCL_CMD(:1).EQ.'"') DCL_CMD = DCL_CMD(2:)
	   END IF
	END IF

	READIT = 0

	LOGIN_SWITCH = CLI$PRESENT('LOGIN')
	SYSTEM_SWITCH = CLI$PRESENT('SYSTEM')
	REVERSE_SWITCH = CLI$PRESENT('REVERSE')

	IER = LIB$SYS_TRNLOG('BULL_DISABLE',LEN_P,BULL_PARAMETER)
	IF (IER.EQ.1.AND.LEN_P.GT.0.AND..NOT.CLI$PRESENT('STOP')
     &	    .AND.BULL_PARAMETER(:LEN_P).NE.'ENABLE') THEN
	   IF (.NOT.LOGIN_SWITCH) THEN
	      WRITE (6,'('' BULLETIN temporarily disabled. Try later.'')')
	   END IF
	   CALL EXIT
	END IF

	CALL SYS$SETDFPROT(,ORIGINAL_DEF_PROT)
		! Save original default protection in case it gets changed

	CALL DCLEXH(%LOC(ENABLE_CTRL_EXIT))		! Declare exit handler

C
C  Check to see if CONTROL Y disabled.  If so, then never disable CONTROL Y.
C  Disabling and enabling CONTROL Y is done so that a person can not break
C  while one of the data files is opened, as that would not allow anyone
C  else to modify the files.  However, if CONTROL Y is already disabled,
C  this is not necessary, and should not be done!
C

	CALL LIB$DISABLE_CTRL(LIB$M_CLI_CTRLY,CTRLY)	! Disable CTRL-Y & -C
	CTRLY = CTRLY .AND. LIB$M_CLI_CTRLY
	CALL GETPRIV				! Check privileges
	CALL CHECK_PRIV_IO(ERR)			! Check privileges on output I/O
	CALL CHECK_DIR_ACCESS()			! Check access to directories
	CALL LIB$ENABLE_CTRL(CTRLY,)		! Renable CTRLY-Y & -C

	IF (ERR.EQ.1) CALL EXIT			! I/O privilege error, so exit

	CALL GETUSER(USERNAME)		! Get the process's username
	IF (.NOT.LOGIN_SWITCH) CALL CHECK_BULLETIN_PRIV(USERNAME)
					! Check if has bulletin privileges

	I = 1				! Strip off folder name if specified
	DO WHILE (I.LE.ILEN)
	   IF (COMMAND_PROMPT(I:I).EQ.' ') THEN
	      COMMAND_PROMPT = COMMAND_PROMPT(:I-1)
	      I = ILEN + 1
	   ELSE
	      I = I + 1
	   END IF
	END DO
	ILEN = 1			! Get executable name to use as prompt
	DO WHILE (ILEN.GT.0)
	   ILEN = MAX(INDEX(COMMAND_PROMPT,':'),INDEX(COMMAND_PROMPT,']'))
	   IF (ILEN.GT.0) THEN
	      COMMAND_PROMPT = COMMAND_PROMPT(ILEN+1:)
	   ELSE
	      DO I=TRIM(COMMAND_PROMPT),1,-1
		 IF (COMMAND_PROMPT(I:I).LT.'A'.OR.
     &			COMMAND_PROMPT(I:I).GT.'Z') THEN
		    COMMAND_PROMPT = COMMAND_PROMPT(:I-1)
		 END IF
	      END DO
	   END IF
	END DO
	COMMAND_PROMPT = COMMAND_PROMPT(:TRIM(COMMAND_PROMPT))//'> '
	IF (COMMAND_PROMPT.EQ.'RUN> '.OR.COMMAND_PROMPT.EQ.'RU> '.OR.
     &	    COMMAND_PROMPT.EQ.'R> ') COMMAND_PROMPT = 'BULLETIN> '

	CALL INIT_COMPRESS

	FOLDER_FILE = FOLDER_DIRECTORY(:TRIM(FOLDER_DIRECTORY))//FOLDER

	CALL CLI$GET_VALUE('SEPARATE',SEPARATE)

	IF (CLI$PRESENT('EDIT')) EDIT_DEFAULT = .TRUE.	! /EDIT switch test

	CALL FIND_BULLCP			! See if BULLCP is running

	IF (CLI$PRESENT('CLEANUP')) THEN	! Test for /CLEANUP switch
	   CALL CLI$GET_VALUE('CLEANUP',BULL_PARAMETER,LEN_P) ! Get folder #
	   READ (BULL_PARAMETER,'(I<LEN_P>)') FOLDER_NUMBER
	   CALL SELECT_FOLDER(.FALSE.,IER)	! Select folder
	   CALL CLEANUP_BULLFILE		! Cleanup empty blocks
	   CALL EXIT				! all done with cleanup
	ELSE IF (CLI$PRESENT('BBOARD')) THEN	! Test for /BBOARD switch
	   CALL BBOARD				! look for BBOARD mail
	   CALL EXIT				! all done with BBOARD
	ELSE IF (CLI$PRESENT('STARTUP').OR.	! BULLCP process control
     &	         CLI$PRESENT('STOP')) THEN
	   CALL CREATE_BULLCP
	ELSE IF (CLI$PRESENT('BULLCP')) THEN	! This is BULLCP, so start
	   IF (.NOT.CLI$GET_VALUE('SELECT_FOLDER',
     &				BULL_PARAMETER,LENP)) THEN
	      CALL RUN_BULLCP			! doing what BULLCP does!
	   ELSE IF (BULL_PARAMETER(:LENP).EQ.'NEWS') THEN
	      CALL NEWS2BULL
	   END IF
	END IF

	CALL GETSTS(STS)			! Get process status word

	IF (SYSTEM_SWITCH.OR.LOGIN_SWITCH) THEN	! If BULLETIN/LOGIN or /SYSTEM
	   IF ((STS.AND.PCB$M_BATCH).GT.0) CALL EXIT	! If BATCH, exit
	   CALL CRELNM('SYS$INPUT','TT')	! Take input from terminal
	END IF

	IF ((STS.AND.PCB$M_NETWRK).EQ.0) THEN
	   DECNET_PROC = .FALSE.
	   ERROR_UNIT = 6

	   CALL ASSIGN_TERMINAL			! Assign terminal

           CALL LIB$ESTABLISH(ERROR_TRAP)       ! Do again due to possible
           IF (.NOT.CLI$PRESENT('PROMPT')) THEN ! KEYPAD init file.
              CALL LIB$REVERT
              CALL CLI$DCL_PARSE(INCMD,BULLETIN_MAINCOMMANDS)
           ELSE
              CALL LIB$REVERT
           END IF

	   IF (.NOT.LOGIN_SWITCH) THEN
	      INCMD = 'SELECT'	! Causes nearest folder name to be selected
	      CALL SELECT_FOLDER(.FALSE.,IER)	! Select GENERAL folder
	      IF (.NOT.IER) RETURN			! If can't access, exit

	      IF (.NOT.TEST_BULLCP()) CALL DELETE_EXPIRED
						! Delete expired messages
	   END IF

C
C  Get page size for the terminal.
C

	   CALL GETPAGSIZ(PAGE_LENGTH,PAGE_WIDTH)

	   IER = CLI$GET_VALUE('WIDTH',BULL_PARAMETER,LEN_P)
	   IF (IER.NE.%LOC(CLI$_ABSENT)) THEN
	      DECODE(LEN_P,'(I<LEN_P>)',BULL_PARAMETER) PAGE_WIDTH
	   END IF

	   IF (CLI$PRESENT('PAGE')) PAGING = .TRUE.

	   IF (SYSTEM_SWITCH) THEN
	      IER = CLI$GET_VALUE('SYSTEM',BULL_PARAMETER,LEN_P)
	      IF (IER.NE.%LOC(CLI$_ABSENT)) THEN	! Days specified?
	         CALL SUBTIME(SYSTEM_LOGIN_BTIM,BULL_PARAMETER(:LEN_P),IER)
		 IF (.NOT.IER) THEN
		    WRITE (6,'('' ERROR: Invalid parameter in /SYSTEM.'')')
		    CALL EXIT
		 END IF
	      END IF
	      IF (.NOT.LOGIN_SWITCH) THEN
	         CALL MODIFY_SYSTEM_LIST(0)
                 CALL READ_IN_FOLDERS
		 FOLDER_Q = SAVE_FOLDER_Q1
		 DO I = 1,SAVE_FOLDER_NUM
	   	    CALL READ_QUEUE(%VAL(FOLDER_Q),FOLDER_Q,FOLDER_COM)
	            IF (TEST2(SYSTEM_FLAG,FOLDER_NUMBER)) THEN
		       CALL SHOW_SYSTEM
		    END IF
	         END DO
	      END IFo
	   END IF

Cd
C  Get user info stored in SYS$LOGIN.  Currently, this simply stores
C  the time of the latest message read for each folder.I
CI

	   CALL OPEN_USERINFO

CE
C  If /LOGIN, display SYSTEM bulletins and subject of non-SYSTEM bulletins.I
CU

	   IF (LOGIN_SWITCH.OR.SYSTEM_SWITCH) THEN	! Is /LOGIN present?
	      CALL LOGIN			! Display SYSTEM bulletins
	      IF (READIT.EQ.0) CALL EXIT	! If no READNEWs not set, exit
	   END IF

CG
C  If new bulletins have been added since the last time bulletins have been
C  read, position bulletin pointer so that next bulletin read is the first new
C  bulletin, and alert user.  If READNEW set and no new bulletins, just exit.L
CC

	   IF (.NOT.DCL_COMMAND) CALL NEW_MESSAGE_NOTIFICATIONS

	   CALL OPEN_OLD_TAG

	ELSE 
	   IF (TEST_BULLCP()) CALL EXIT
	   DECNET_PROC = .TRUE.
	   ERROR_UNIT = 5
	END IF

CM
C  The MAIN loop for processing bulletin commands.
C2

	DIR_COUNT = 0	! # directory entry to continue bulletin read fromD
	READ_COUNT = 0	! # block that bulletin READ is to continue from
	FOLDER_COUNT = 0 ! # folder entry to continue SHOW/ALL folder from.
	INDEX_COUNT = 0

	IER = LIB$SYS_TRNLOG('BULL_HELP',HLEN,HELP_DIRECTORY)
	IF (IER.NE.1) THENS
	   HELP_DIRECTORY = 'SYS$HELP:'
	   HLEN = 9
	ELSE IF (HELP_DIRECTORY(HLEN:HLEN).NE.':'.AND.
     &		 HELP_DIRECTORY(HLEN:HLEN).NE.']') THENP
	   HELP_DIRECTORY = HELP_DIRECTORY(:HLEN)//':' 
	   HLEN = HLEN + 1T
	END IFO

	LPROMPT = TRIM(COMMAND_PROMPT)C
	PROMPT = CHAR(10)//COMMAND_PROMPT(:LPROMPT)//' 'S
	LPROMPT = LPROMPT + 2

	DO WHILE (1)R

	   IF (.NOT.DCL_COMMAND) THEN
	      CALL COMMAND_INPUT(IER)
	   ELSE
	      IF (INDEX(DCL_CMD,';').GT.0) THEN
	         INCMD = DCL_CMD(:INDEX(DCL_CMD,';')-1)
	         DCL_COMMAND = DCL_CMD(INDEX(DCL_CMD,';'):).NE.';'E
	         DCL_CMD = DCL_CMD(INDEX(DCL_CMD,';')+1:)
	      ELSE.
	         INCMD = DCL_CMD(
	         DCL_CMD = ' '(
	      END IFL
	      IER = TRIM(INCMD)
	   END IF

	   IF (IER.EQ.-2) THENT
	      IER = RMS$_EOFE
	   ELSE IF (IER.LE.0) THENT
	      IER = %LOC(CLI$_NOCOMD)
	   ELSE
	      DO WHILE (IER.GT.0.AND.INCMD(:1).EQ.' ')M
		 INCMD = INCMD(2:IER) 
		 IER = IER - 1
	      END DON
	      IF (IER.GT.0.AND.INCMD(:1).GE.'0'.AND.INCMD(:1).LE.'9') THENR
		 INCMD = 'READ '//INCMDE
	      END IF
	      IER=CLI$DCL_PARSE(INCMD,BULLETIN_SUBCOMMANDS,LIB$GET_INPUT)
	   END IF

	   IF (IER.EQ.RMS$_EOF) THEND
	      CALL EXIT			! If no command, exit
	   ELSE IF (IER.EQ.%LOC(CLI$_NOCOMD)) THEN  ! If just RETURN entered'
	      INCMD = ' '		! Make sure there is noneE
	      LEN_P = 0			! Indicate no parameter in commandA
	      IF (DIR_COUNT.GT.0) THEN		! If still more dir entries
		 CALL DIRECTORY(DIR_COUNT)	! continue outputting them'
	      ELSE IF (INDEX_COUNT.GT.0) THEN
	         CALL FULL_DIR(INDEX_COUNT)
	      ELSE IF (FOLDER_COUNT.GT.0) THEN	! If more folder entries
		 CALL DIRECTORY_FOLDERS(FOLDER_COUNT) ! continue outputting them
	      ELSE				! Else try to read next bulletinL
		 CALL READ_MSG(READ_COUNT,BULL_POINT+1)  ! or finish old one
	         DIR_COUNT = 0L
	         FOLDER_COUNT = 0
	         INDEX_COUNT = 0D
	      END IFa
	      GO TO 100				! Loop to read new command
	   ELSE IF (.NOT.IER) THEN		! If command has errort
	      GO TO 100				! ask for new commandf
	   END IF

           IER = MINGT0(INDEX(INCMD(:TRIM(INCMD)),' '),INDEX(INCMD,'/'))
	   IF (IER.GT.0) INCMD = '    '//INCMD(IER:)	! Save qualifiersY
	   CALL CLI$GET_VALUE('$VERB',INCMD(:4))	! Get user's command.R

	   IF (INCMD(:4).EQ.'BACK'.AND.DIR_COUNT.NE.0) THEN
	      DIR_COUNT = -1i
	      CALL DIRECTORY(DIR_COUNT)
	      INCMD = ' '
C	   ELSE IF (INCMD(:4).EQ.'BACK'.AND.FOLDER_COUNT.NE.0) THENn
C	      FOLDER_COUNT = -1E
C	      CALL DIRECTORY_FOLDERS(FOLDER_COUNT)
C	      INCMD = ' 'E
	   ELSE
	      DIR_COUNT = 0			! Reinit display pointers
	      READ_COUNT = 0E
	      FOLDER_COUNT = 0!
	      INDEX_COUNT = 0
	   END IF

	   IF_ADD = INCMD(:3).EQ.'ADD' 
	   IF (IF_ADD) IF_ADD = .NOT.CLI$PRESENT('SELECT_FOLDER')
	   IF (READ_ONLY.AND.(IF_ADD.OR.INCMD(:3).EQ.'DEL'R
     &	     .OR.INCMD(:3).EQ.'CHA'.OR.INCMD(:3).EQ.'REP')) THEN 
						! FOLDER can only be read?
	     WRITE (6,'('' ERROR: Access to folder limited to reading.'')')
	   ELSE IF (INCMD(:3).EQ.'ADD') THEN	! ADD?
	     IF (NEWS_FEED().OR.REMOTE_SET.GE.3) THEN
		INCMD = 'POST '//INCMD(4:)
	        IER=CLI$DCL_PARSE(INCMD,BULLETIN_SUBCOMMANDS,LIB$GET_INPUT)
		CALL RESPOND
	     ELSE
	        CALL ADDD
	     END IF
	   ELSE IF (INCMD(:3).EQ.'ATT') THEN	! ATTACH?P
	     CALL ATTACH
	   ELSE IF (INCMD(:4).EQ.'BACK') THEN	! BACK?
	     IF (BULL_POINT.LE.1) THENM
	        WRITE(6,1060)
	     ELSE
	        CALL READ_MSG(READ_COUNT,BULL_POINT-1)  ! Try to read previousP
	     END IF
	   ELSE IF (INCMD(:4).EQ.'CHAN') THEN		! CHANGE?
	     CALL REPLACE				! Replace old bulletin
	   ELSE IF (INCMD(:4).EQ.'COPY') THEN		! COPY?P
	     CALL MOVE(.FALSE.)
	   ELSE IF (INCMD(:4).EQ.'CREA') THEN		! CREATE?w
	     CALL CREATE_FOLDER			! Go create the folders
	   ELSE IF (INCMD(:4).EQ.'CURR') THEN		! CURRENT?
	     READ_COUNT = -1		! Reread current message from beginning.E
	     CALL READ_MSG(READ_COUNT,BULL_POINT)
	   ELSE IF (INCMD(:4).EQ.'DELE') THEN 	! DELETE?C
	     CALL DELETE_MSG			! Go delete bulletin
	   ELSE IF (INCMD(:4).EQ.'DIRE') THEN		! DIRECTORY?
	     IF (CLI$PRESENT('FOLDER').OR.		! /FOLDER specified?O
     &		 CLI$PRESENT('NEWS')) THEN		! or /NEWS?B
		CALL DIRECTORY_FOLDERS(FOLDER_COUNT)	! Show all foldersn
	     ELSE IF (CLI$PRESENT('SELECT_FOLDER')) THEN! Folder specified?
	        CALL SELECT_FOLDER(.TRUE.,IER)		! Try to select folderE
	        IF (IER) THEN				! If successful)
	           CALL DIRECTORY(DIR_COUNT)		! Show messages
		END IF
	     ELSE
	        CALL DIRECTORY(DIR_COUNT)		! Show messagesU
	     END IF
	   ELSE IF (INCMD(:4).EQ.'FILE'.OR.
     &		    INCMD(:4).EQ.'EXTR') THEN		! FILE?
	     CALL FILE					! Copy bulletin to fileE
	   ELSE IF (INCMD(:4).EQ.'EXCL') THEN		! EXCLUDE?
	     CALL INCLUDE(.TRUE.)
	   ELSE IF (INCMD(:1).EQ.'E'.OR.
     &		    INCMD(:4).EQ.'QUIT') THEN		! EXIT?
	     CALL EXIT				! Exit from program
	   ELSE IF (INCMD(:4).EQ.'FIRS') THEN		! FIRST?
	     READ_COUNT = -1W
	     BULL_READ = 1E
	     CALL READ_MSG(READ_COUNT,BULL_READ)
	   ELSE IF (INCMD(:4).EQ.'HELP') THEN		! HELP? 
	     CALL HELP(HELP_DIRECTORY(:HLEN)//'BULL.HLB')	! Get help 
	   ELSE IF (INCMD(:3).EQ.'IND') THEN		! INDEX?'
	     INDEX_COUNT = 1i
	     CALL FULL_DIR(INDEX_COUNT)
	   ELSE IF (INCMD(:4).EQ.'INCL') THEN		! INCLUDE?
	     CALL INCLUDE(.FALSE.)S
	   ELSE IF (INCMD(:4).EQ.'LAST') THEN		! LAST?D
	     READ_COUNT = -1G
	     BULL_READ = 9999999C
	     CALL READ_MSG(READ_COUNT,BULL_READ)t
	   ELSE IF (INCMD(:4).EQ.'MARK') THEN		! MARK?,
	     CALL TAG(.TRUE.,1)
	   ELSE IF (INCMD(:4).EQ.'MAIL'.OR.
     &		    INCMD(:4).EQ.'FORW') THEN		! MAIL?
	     CALL MAILE
	   ELSE IF (INCMD(:3).EQ.'MOD') THEN		! MODIFY?
	     CALL MODIFY_FOLDER
	   ELSE IF (INCMD(:4).EQ.'MOVE') THEN		! MOVE?G
	     CALL MOVE(.TRUE.) 
	   ELSE IF (INCMD(:4).EQ.'NEWS') THEN		! NEWS
	     CALL DIRECTORY_FOLDERS(FOLDER_COUNT)	! Show new folders_
	   ELSE IF (INCMD(:4).EQ.'NEXT'.OR.INCMD(:1).EQ.'N') THEN    ! NEXT?R
	     CALL READ_MSG(READ_COUNT,BULL_POINT+1)	! Read next bulletin 
	   ELSE IF (INCMD(:4).EQ.'POST') THEN		! POST?N
	      IF (BTEST(FOLDER_FLAG,11)) THEN
                 INCMD = 'ADD '//INCMD(5:)
	         IER=CLI$DCL_PARSE(INCMD,BULLETIN_SUBCOMMANDS,LIB$GET_INPUT)T
                 CALL ADDR
	      ELSEp
		 CALL RESPONDE
	      END IF 
	   ELSE IF (INCMD(:4).EQ.'PRIN') THEN		! PRINT?
	     CALL PRINT(0,.TRUE.)			! Printout bulletin
	   ELSE IF (INCMD(:4).EQ.'READ') THEN		! READ?R
	     IER = CLI$GET_VALUE('BULLETIN_NUMBER',BULL_PARAMETER,LEN_P) 
	     IF (IER.NE.%LOC(CLI$_ABSENT)) THEN		! Bulletin specified? 
	        DECODE(LEN_P,'(I<LEN_P>)',BULL_PARAMETER) BULL_READ	! Yes
		READ_COUNT = -1 
		CALL READ_MSG(READ_COUNT,BULL_READ) 
	     ELSE
		CALL READ_MSG(READ_COUNT,BULL_POINT+1)
	     END IF
	   ELSE IF (INCMD(:3).EQ.'REM') THEN		! REMOVE?
	     CALL REMOVE_FOLDER
	   ELSE IF (INCMD(:3).EQ.'REP') THEN		! REPLY? 
	     IF (REMOTE_SET.GE.3.OR.b
     &	        INDEX(FOLDER_DESCRIP,'<').GT.0) THENW
		CALL RESPOND
	     ELSE
	        CALL REPLY
	     END IF
	   ELSE IF (INCMD(:4).EQ.'RESP') THEN		! RESPOND?
	     CALL RESPOND
	   ELSE IF (INCMD(:4).EQ.'RESE') THEN		! RESET?
	     CALL RESET
	   ELSE IF (INCMD(:3).EQ.'SEA') THEN		! SEARCH?
	     CALL SEARCH(READ_COUNT)n
	   ELSE IF (INCMD(:3).EQ.'SEE') THEN		! SEEN?
	     CALL TAG(.TRUE.,2)
	   ELSE IF (INCMD(:3).EQ.'SEL') THEN		! SELECT?
	     CALL SELECT_FOLDER(.TRUE.,IER)
	   ELSE IF (INCMD(:3).EQ.'SET') THEN		! SET?O
	     CALL CLI$GET_VALUE('SET_PARAM1',BULL_PARAMETER)T
	     IF (BULL_PARAMETER(:1).EQ.'F') THEN		! SET FOLDER?
		CALL SELECT_FOLDER(.TRUE.,IER)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'PRI') THEN		! SET PRIVS?
		CALL SET_PRIVe
	     ELSE IF (BULL_PARAMETER(:2).EQ.'PA') THEN		! SET PAGE?
		PAGING = .TRUE.
		WRITE (6,'('' PAGE has been set.'')')t
	     ELSE IF (BULL_PARAMETER(:1).EQ.'K') THEN		! SET KEYPAD?T
		CALL SET_KEYPADL
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOK') THEN		! SET NOKEYPAD?$
		CALL SET_NOKEYPAD
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOPA') THEN	! SET NOPAGE?I
		PAGING = .FALSE.
		WRITE (6,'('' NOPAGE has been set.'')')E
	     ELSE IF (FOLDER_NUMBER.EQ.-1.AND.REMOTE_SET.EQ.1) THEN
	        WRITE (6,'('' ERROR: Invalid command for remote folder.'')')/
	     ELSE IF (BULL_PARAMETER(:2).EQ.'SY') THEN		! SET SYSTEM?
	 	CALL SET_SYSTEM(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOSY') THEN	! SET NOSYSTEM? 
	 	CALL SET_SYSTEM(.FALSE.)M
	     ELSE IF (BULL_PARAMETER(:2).EQ.'BB') THEN		! SET BBOARD?
		CALL SET_BBOARD(.TRUE.) 
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOBB') THEN	! SET NOBBOARD? 
		CALL SET_BBOARD(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:2).EQ.'DU') THEN		! SET DUMP?
		CALL SET_FOLDER_FLAG(.TRUE.,1,'DUMP') 
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODU') THEN	! SET NODUMP?%
		CALL SET_FOLDER_FLAG(.FALSE.,1,'DUMP')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'ST') THEN		! SET STRIP?	
		CALL SET_FOLDER_FLAG(.TRUE.,4,'STRIP')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOST') THEN	! SET NOSTRIP?
		CALL SET_FOLDER_FLAG(.FALSE.,4,'STRIP') 
	     ELSE IF (BULL_PARAMETER(:2).EQ.'DI') THEN		! SET DIGEST?
		CALL SET_FOLDER_FLAG(.TRUE.,5,'DIGEST')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODI') THEN	! SET NODIGEST?C
		CALL SET_FOLDER_FLAG(.FALSE.,5,'DIGEST')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'AL') THEN		! SET ALWAYS?
		CALL SET_FOLDER_FLAG(.TRUE.,7,'ALWAYS') 
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOAL') THEN	! SET NOALWAYS? 
		CALL SET_FOLDER_FLAG(.FALSE.,7,'ALWAYS')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'CO') THEN		! SET COMPRESS?
		CALL SET_FOLDER_FLAG(.TRUE.,12,'COMPRESS')
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOCO') THEN      ! SET NOCOMPRESS?
		CALL SET_FOLDER_FLAG(.FALSE.,12,'COMPRESS')!
	     ELSE IF (BULL_PARAMETER(:2).EQ.'PO') THEN	    ! SET POST_ONLY?
		CALL SET_FOLDER_FLAG(.TRUE.,10,'POST_ONLY') 
		IF (BTEST(FOLDER_FLAG,11)) THEN 
                   CALL SET_FOLDER_FLAG(.FALSE.,11,'ADD_ONLY')
	        END IFc
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOPO') THEN    ! SET NOPOST_ONLY?O
		CALL SET_FOLDER_FLAG(.FALSE.,10,'POST_ONLY')
	     ELSE IF (BULL_PARAMETER(:2).EQ.'AD') THEN	    ! SET ADD_ONLY?)
		CALL SET_FOLDER_FLAG(.TRUE.,11,'ADD_ONLY')
		IF (BTEST(FOLDER_FLAG,10)) THEN 
                   CALL SET_FOLDER_FLAG(.FALSE.,10,'POST_ONLY')M
		END IF
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOAD') THEN    ! SET NOADD_ONLY?
		CALL SET_FOLDER_FLAG(.FALSE.,11,'ADD_ONLY') 
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOTI') THEN	! SET NOTIFY?D
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT')) 
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(1,-1,-1)O
		ELSE
		   CALL SET_USER_FLAG(1,-1,-1)
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'E') THEN	! SET EXPIRE?
	        IER = CLI$GET_VALUE('EXPIRATION',BULL_PARAMETER,LEN_P)D
		IF (LEN_P.LE.3) THEN
	           READ (BULL_PARAMETER,'(I<LEN_P>)') LIMIT
		   CALL SET_FOLDER_EXPIRE_LIMIT(LIMIT)
		ELSE
		   WRITE (6,'('' ERROR: Invalid expiration specified.'')')
		END IF
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NODE') THEN	! SET NODE?_
		CALL SET_NODE(.TRUE.) 
	     ELSE IF (BULL_PARAMETER(:6).EQ.'NONODE') THEN	! SET NONODE?M
		CALL SET_NODE(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOE') THEN	! SET NOEXPIRE?
		CALL SET_FOLDER_EXPIRE_LIMIT(0)A
	     ELSE IF (BULL_PARAMETER(:5).EQ.'NONOT') THEN	! SET NONOTIFY?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))!
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(0,-1,-1):
		ELSE
		   CALL SET_USER_FLAG(0,-1,-1)
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'S') THEN		! SET SHOWNEW?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))a
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,1)
		ELSE
		   CALL SET_USER_FLAG(-1,0,1)a
		END IF
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOS') THEN	! SET NOSHOWNEW?)
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT')).
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0)C
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'R') THEN		! SET READNEW?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))T
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,1,0)
		ELSE
		   CALL SET_USER_FLAG(-1,1,0)D
		END IF
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOR') THEN	! SET NOREADNEW?E
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))	
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0) 
		END IF
	     ELSE IF (BULL_PARAMETER(:2).EQ.'BR') THEN		! SET BRIEF?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))N
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,1,1)
		ELSE
		   CALL SET_USER_FLAG(-1,1,1)D
		END IF
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOBR') THEN	! SET NOBRIEF?
		IF (CLI$PRESENT('DEFAULT').OR.CLI$PRESENT('ALL').OR.
     &		    CLI$PRESENT('PERMANENT').OR.CLI$PRESENT('NOPERMANENT'))L
     &		    THEN
		   CALL SET_FOLDER_DEFAULT(-1,0,0)
		ELSE
		   CALL SET_USER_FLAG(-1,0,0)A
		END IF
	     ELSE IF (BULL_PARAMETER(:1).EQ.'A') THEN		! SET ACCESS?T
		CALL SET_ACCESS(.TRUE.)9
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOA') THEN	! SET NOACCESS?
		CALL SET_ACCESS(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:1).EQ.'C') THEN	! SET CONTINUOUS_BRIEF
		CALL SET_BRIEF_CONTINUOUS(.TRUE.)	
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOC') THEN	! SET NOCONTINUOUS_BRIEF?
		CALL SET_BRIEF_CONTINUOUS(.FALSE.)
	     ELSE IF (BULL_PARAMETER(:1).EQ.'G') THEN		! SET GENERIC?
		CALL SET_GENERIC(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:3).EQ.'NOG') THEN	! SET NOGENERIC?S
		CALL SET_GENERIC(.FALSE.) 
	     ELSE IF (BULL_PARAMETER(:3).EQ.'LOG') THEN		! SET LOGIN?
		CALL SET_LOGIN(.TRUE.)
	     ELSE IF (BULL_PARAMETER(:5).EQ.'NOLOG') THEN	! SET NOLOGIN?S
		CALL SET_LOGIN(.FALSE.)I
	     ELSE IF (BULL_PARAMETER(:3).EQ.'PRO') THEN	 ! SET PROMPT_EXPIRE?
		CALL SET_FOLDER_FLAG(.FALSE.,3,'PROMPT_EXPIRE')O
	     ELSE IF (BULL_PARAMETER(:4).EQ.'NOPR') THEN ! SET NOPROMPT_EXPIRE?
		CALL SET_FOLDER_FLAG(.TRUE.,3,'PROMPT_EXPIRE')
	     ELSE IF (BULL_PARAMETER(:3).EQ.'DEF') THEN	! SET DEFAULT_EXPIRE?
		CALL SET_DEFAULT_EXPIREE
	     ELSE IF (BULL_PARAMETER(:2).EQ.'NE') THEN	! SET NEWS?_
		CALL SET_NEWSM
	     END IF
	   ELSE IF (INCMD(:4).EQ.'SHOW') THEN		! SHOW?t
	     CALL CLI$GET_VALUE('SHOW_PARAM1',BULL_PARAMETER,LEN_P)
	     IF (BULL_PARAMETER(:2).EQ.'FL') THEN	! SHOW FLAGS?
		CALL SHOW_FLAGSD
	     ELSE IF (BULL_PARAMETER(:2).EQ.'FO') THEN	! SHOW FOLDER?
	        CALL SHOW_FOLDER:
	     ELSE IF (BULL_PARAMETER(:1).EQ.'K') THEN	! SHOW KEYPAD
	        CALL SHOW_KEYPAD(HELP_DIRECTORY(:HLEN)//'BULL.HLB')
	     ELSE IF (BULL_PARAMETER(:1).EQ.'N') THEN	! SHOW NEW?
		SAVE_FOLDER_NUMBER = FOLDER_NUMBER
		SAVE_FOLDER = FOLDER
		CALL NEW_MESSAGE_NOTIFICATIONE
		FOLDER1 = SAVE_FOLDER?
		FOLDER_NUMBER = SAVE_FOLDER_NUMBER
		CALL SELECT_FOLDER(.FALSE.,IER) 
	     ELSE IF (BULL_PARAMETER(:1).EQ.'P') THEN	! SHOW PRIVILEGES? 
		CALL SHOW_PRIV
	     ELSE IF (BULL_PARAMETER(:1).EQ.'U') THEN	! SHOW USER? 
	        CALL SHOW_USER 
	     ELSE IF (BULL_PARAMETER(:1).EQ.'V') THEN	! SHOW VERSION?
		CALL SHOW_VERSION
	     END IF
           ELSE IF (INCMD(:4).EQ.'SPAW') THEN           ! SPAWN command?
             CALL SPAWN_PROCESSR
           ELSE IF (INCMD(:3).EQ.'SUB') THEN            ! SUBSCRIBE command?
             CALL SUBSCRIBE.
	   ELSE IF (INCMD(:4).EQ.'UNDE') THEN		! UNDELETE? 
	     CALL UNDELETEE
	   ELSE IF (INCMD(:3).EQ.'UNM') THEN		! UNMARK?
	     CALL TAG(.FALSE.,1)s
	   ELSE IF (INCMD(:4).EQ.'UNSE') THEN		! UNSEEN?.
	     CALL TAG(.FALSE.,2)T
           ELSE IF (INCMD(:4).EQ.'UNSU') THEN           ! UNSUBSCRIBE command?
             CALL UNSUBSCRIBE
	   END IF

100	   CONTINUE4

	   IF (DCL_COMMAND.AND.TRIM(DCL_CMD).EQ.0) CALL EXITR

	END DO 

1010	FORMAT(Q,A)
1060	FORMAT(' ERROR: There are no more preceding messages.')

	END



	SUBROUTINE COMMAND_INPUT(IER)

	IMPLICIT INTEGER (A - Z)'

	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD

	COMMON /PROMPT_PROMPT/ PROMPT,LPROMPT
	CHARACTER*44 PROMPT

	CALL GET_INPUT_PROMPT(INCMD,IER,PROMPT(:LPROMPT))

	RETURN.

	END





	SUBROUTINE ADDE
C(
C  SUBROUTINE ADD!
CT
C  FUNCTION: Adds bulletin to bulletin file.
CI
	IMPLICIT INTEGER (A - Z)O

	COMMON /POINT/ BULL_POINT

	COMMON /BULLPAR/ BULL_PARAMETER,LEN_P
	CHARACTER*64 BULL_PARAMETER

	COMMON /NODE_INFO/ NODES,LOCAL_NODE_FOUND,NODE_NUM,
     &				NODE_ERROR,POINT_NODE4
	CHARACTER*32 NODES(10)O
	LOGICAL LOCAL_NODE_FOUND,NODE_ERROR

	COMMON /DECNET/ DECNET_PROC,ERROR_UNIT2
	LOGICAL DECNET_PROC

	COMMON /EDIT/ EDIT_DEFAULTG
	DATA EDIT_DEFAULT/.FALSE./E

	COMMON /COMMAND_LINE/ INCMD
	CHARACTER*132 INCMD

	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT

	COMMON /LAST_RECORD_WRITTEN/ OCOUNT

	INCLUDE 'BULLDIR.INC'

	INCLUDE 'BULLUSER.INC'D

	INCLUDE 'BULLFOLDER.INC'_

	COMMON /INDESCRIP/ INDESCRIPE
	CHARACTER*(INPUT_LENGTH) INDESCRIP.

	COMMON /SYSTEM_FOLDERS/ SYSTEM_FLAG(FLONG),NODENAME
	CHARACTER NODENAME*8Y

	CHARACTER INEXDATE*12,INEXTIME*12

	CHARACTER INLINE*80,OLD_FOLDER*44,LOCAL_NODE*8L

	EXTERNAL CLI$_ABSENT,CLI$_NEGATED

	EDITIT = (CLI$PRESENT('EDIT').OR.EDIT_DEFAULT).AND.
     &           (CLI$PRESENT('EDIT').NE.%LOC(CLI$_NEGATED))

	IF (CLI$PRESENT('EXTRACT').AND..NOT.EDITIT) THENE
	   WRITE (6,'('' ERROR: Cannot extract text without /EDIT.'')')
	   RETURN
	END IFS

	IF (EDITIT.AND..NOT.CLI$PRESENT('EXTRACT'))
     &	    .AND..NOT.CLI$PRESENT('FILESPEC')) THEN
	   CALL LIB$DELETE_FILE('SYS$LOGIN:BULL.SCR;*')
	END IF

	CALL DISABLE_CTRL		! Disable CTRL-Y & -CE

	ALLOW = SETPRV_PRIV()

	OLD_FOLDER_NUMBER = FOLDER_NUMBER
	OLD_FOLDER = FOLDER

	LEN_P = 0

	IF (CLI$PRESENT('EXTRACT')) THENS
	   BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'A
	   LEN_P = TRIM(BULL_PARAMETER)
	   OPEN(UNIT=3,FILE=BULL_PARAMETER(:LEN_P),IOSTAT=IER,
     &		RECL=LINE_LENGTH,)
     &		STATUS='NEW',CARRIAGECONTROL='LIST',FORM='FORMATTED')T

	   IF (IER.NE.0) THEN
	      CALL ERRSNS(IDUMMY,IER)
	      CALL SYS_GETMSG(IER)L
	      GO TO 910
	   END IF

	   CALL OPEN_BULLFIL_SHARED

	   ILEN = LINE_LENGTH + 1

	   CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)T
	   IF (ILEN.GT.0.AND.INPUT(:6).EQ.'From: ') THENN
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END IF
	   IF (ILEN.GT.0.AND.INPUT(:6).EQ.'Subj: ') THEN	
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END IF

	   DO WHILE (ILEN.GT.0)			! Copy bulletin into file
	      IF (CLI$PRESENT('NOINDENT')) THEN
	         WRITE (3,'(A)') INPUT(:ILEN)
	      ELSEL
	         WRITE (3,'(A)') '>'//INPUT(:ILEN)_
	      END IFI
	      CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	   END DO

90	   CALL CLOSE_BULLFIL
	END IFE

	IF (CLI$PRESENT('FILESPEC')) THEN
	   IER = CLI$GET_VALUE('FILESPEC',BULL_PARAMETER,LEN_P)
	   CALL DISABLE_PRIVS
	   IF (.NOT.CLI$PRESENT('EXTRACT')) THEN(
	      OPEN (UNIT=3,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD',T
     &		READONLY,SHARED,ERR=920,FORM='FORMATTED') 
	   ELSE
	      OPEN (UNIT=4,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD',$
     &		READONLY,SHARED,ERR=920,FORM='FORMATTED')&
	      IER = 0
	      ICOUNT = 0L
	      DO WHILE (IER.EQ.0)
		 READ (4,'(Q,A)',IOSTAT=IER) ILEN,INPUTU
		 IF (IER.EQ.0) THEN	
		    IF (ICOUNT.EQ.0) WRITE (3,'(A)') ' '
		    ICOUNT = ICOUNT + 1(
		    WRITE (3,'(A)') INPUT(:ILEN)
		 END IFS
	      END DOO
	      CLOSE (UNIT=4).
	      BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'
	      LEN_P = TRIM(BULL_PARAMETER) 
	   END IF
	   CALL ENABLE_PRIVS	! Reset SYSPRV privileges 
	END IFF

	SELECT_FOLDERS = .FALSE. 
	IF (CLI$PRESENT('SELECT_FOLDER')) THENN
	   CALL GET_FOLDER_INFO(IER)R
	   IF (.NOT.IER) GO TO 910N
	   SELECT_FOLDERS = .TRUE.$
	ELSE(
	   NODE_NUM = 1
	   NODES(1) = OLD_FOLDER
	END IF 

	IF (FOLDER_NUMBER.GT.0.AND.		! If folder set and
     &	    CLI$PRESENT('NODES')) THEN		! Decnet nodes specified?
	   WRITE (6,'('' ERROR: /NODES cannot be used with folder set.'')')
	   GO TO 910(
	END IF.

	IF (.NOT.BTEST(FOLDER_FLAG,2).AND.FOLDER_NUMBER.NE.0.AND.
     &	   (CLI$PRESENT('SYSTEM').OR.		! Is /SYSTEM switch present?
     &	    CLI$PRESENT('BROADCAST').OR.	! Is /BROADCAST swtich present?A
     &	    CLI$PRESENT('SHUTDOWN'))) THEN	! Is /SHUTDOWN switch present?
	   WRITE (6,'('' ERROR: Folder is not a SYSTEM folder.'')')
	   GO TO 910(
	END IFE

	IF (CLI$PRESENT('SYSTEM')) THEN		! Is /SYSTEM switch present?
	   IF (.NOT.ALLOW) THEN			! If no privilegesF
	      WRITE(ERROR_UNIT,1070)		! Tell user
	      GO TO 910				! and abortR
	   END IF
	   SYSTEM = 1				! Set system bit
	ELSE 
	   SYSTEM = 0				! Clear system bit
	END IFA

	IF (CLI$PRESENT('BROADCAST')) THEN	! Is /BROADCAST switch present?E
	   IF (.NOT.(ALLOW.OR.OPER_PRIV())) THEN	! If no privileges
	      WRITE(ERROR_UNIT,1080)		! Tell user
	      GO TO 910				! and abort)
	   ELSE IF (CLI$PRESENT('CLUSTER')) THEN$
	      SYSTEM = SYSTEM.OR.8R
	   END IF
	END IFL

	IF (CLI$PRESENT('PERMANENT')) THEN	! Is /PERMANENT switch present?C
	   IF (F_EXPIRE_LIMIT.GT.0.AND..NOT. ! Expiration limit present
     &		FOLDER_ACCESS(USERNAME,FOLDER_FLAG,FOLDER_OWNER)) THEN
	      WRITE(ERROR_UNIT,1083)3
	      GO TO 910
	   ELSE
	      SYSTEM = SYSTEM.OR.2		! Set permanent bit
	      INEXDATE = '5-NOV-2000'
	      INEXTIME = '00:00:00.00'T
	   END IF
	END IFU

	IF (CLI$PRESENT('SHUTDOWN')) THEN	! Is /SHUTDOWN switch present?U
	   IF (.NOT.ALLOW) THEN			! If no privileges)
	      WRITE(ERROR_UNIT,1082)		! Tell user
	      GO TO 910				! and abortG
	   ELSE
	      IER = CLI$GET_VALUE('SHUTDOWN',INLINE)'
	      IF (IER.NE.%LOC(CLI$_ABSENT)) THENC
		 IF (REMOTE_SET) THEN		! Can't specify node name if 
		    WRITE (6,1090)		! remote folder, as no code 
		    GO TO 910			! present to send the name.S
		 END IFS
	         CALL GET_NODE_NUMBER_OTHER(NODE_NUMBER,NODE_AREA,INLINE)
		 IF (NODE_AREA.EQ.0) GO TO 910	! Invalid node name
	      ELSE'
	         CALL GET_NODE_NUMBER(NODE_NUMBER,NODE_AREA)'
	      END IFE
	      SYSTEM = SYSTEM.OR.4		! Set shutdown bit,
	      INEXDATE = '5-NOV-2000'
              WRITE (INEXTIME(1:),'(I2)') NODE_NUMBER/60
              WRITE (INEXTIME(3:),'(I2)') MOD(NODE_NUMBER,60).
              WRITE (INEXTIME(7:),'(I2)') NODE_AREA/60
              WRITE (INEXTIME(9:),'(I2)') MOD(NODE_AREA,60)A
	      DO I=1,11
		 IF (INEXTIME(I:I).EQ.' ') INEXTIME(I:I) = '0'
	      END DOE
	      INEXTIME = INEXTIME(1:2)//':'//INEXTIME(3:4)//':'//
     &			 INEXTIME(7:8)//'.'//INEXTIME(9:10)
	   END IF
	END IFH

	SELECT_NODES = .FALSE.B
	IF (CLI$PRESENT('NODES')) THENS
	   CALL GET_NODE_INFO
	   IF (NODE_ERROR) GO TO 940L
	   SELECT_NODES = .TRUE.E
	END IF_

	IF ((SYSTEM.AND.7).LE.1.AND.(CLI$PRESENT('SELECT_FOLDER').OR.
     &	    CLI$PRESENT('NODES').OR..NOT.BTEST(FOLDER_FLAG,10))) THEN
	   CALL GET_EXPIRED(INPUT,IER)          ! Not permanent or shutdown S
	   IF (.NOT.IER) GO TO 910 
	   INEXDATE = INPUT(:11)(
	   INEXTIME = INPUT(13:23)L
	END IF	

	IF (INCMD(:3).EQ.'REP') THEN		! REPLY?E
	   LENDES = TRIM(INDESCRIP)		! filled in by main subroutine
	ELSE IF (CLI$PRESENT('SUBJECT')) THEN	! /SUBJECT specified
	   CALL CLI$GET_VALUE('SUBJECT',INDESCRIP,LENDES)
	ELSEM
	   WRITE(6,1050)			! Request header for bulletin 
	   CALL GET_LINE(INDESCRIP,LENDES)	! Get input line
	   IF (LENDES.LE.0) GO TO 910
	END IFR

	LENDES = MIN(LEN(INDESCRIP)-6,LENDES)	! Make room for "Subj: "E

CD
C  If file specified in ADD command, read file to obtain bulletin.
C  Else, read the bulletin from the terminal.S
C1

	IF (EDITIT.AND..NOT.DECNET_PROC) THEN	! If /EDIT specifiedA
	   IF (LEN_P.EQ.0) THEN			! If no file param specifiedU
	      CALL MAILEDIT('SYS$LOGIN:BULL.SCR',' ')
	      OPEN (UNIT=3,FILE='SYS$LOGIN:BULL.SCR',STATUS='OLD', 
     &		 DISPOSE='DELETE',ERR=910,FORM='FORMATTED')
	      LEN_P = 1
	   ELSE
	      CLOSE (UNIT=3):
	      CALL MAILEDIT(BULL_PARAMETER(:LEN_P),'SYS$LOGIN:BULL.SCR') 
	      IF (CLI$PRESENT('EXTRACT')) THENA
	         CONTEXT = 0A
	         CALL LIB$FIND_FILE('SYS$LOGIN:BULL.SCR',INPUT,CONTEXT)
	         VERSION = INDEX(INPUT,';') + 1
	         IF (INPUT(VERSION:VERSION).EQ.'1') THENR
	            CALL LIB$DELETE_FILE('SYS$LOGIN:BULL.SCR;*')N
	         END IF
	      END IFl
	      OPEN (UNIT=3,FILE='SYS$LOGIN:BULL.SCR',STATUS='OLD',M
     &		 DISPOSE='DELETE',ERR=910,FORM='FORMATTED')M
	   END IF
	   BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'D
	   LEN_P = TRIM(BULL_PARAMETER)
	END IF 

	ICOUNT = 0				! Line count for bulletin

	END = 0
	BLENGTH = 35L
	IF (CLI$PRESENT('BELL')) BLENGTH = 37
	IF (LEN_P.GT.0) THEN			! If file param in ADD command
	   DO WHILE(1)				! Read until end of file to
	      READ (3,'(Q,A)',END=10) ILEN,INPUT! get record count
	      IF (ILEN.GT.LINE_LENGTH) GO TO 950_
	      ICOUNT = ICOUNT + 1 + MIN(ILEN,80)T
	      BLENGTH = BLENGTH + ILEN - 1 + 2U
	      IF (ILEN.EQ.0) ICOUNT = ICOUNT + 1! COPY_BULL writes line withC
	   END DO				! 1 space for blank line
	ELSE					! If no input file
	   BULL_PARAMETER = 'SYS$LOGIN:BULL.SCR'D
	   LEN_P = TRIM(BULL_PARAMETER)
	   OPEN (UNIT=3,DISPOSE='DELETE',FILE='SYS$LOGIN:BULL.SCR',
     &		STATUS='NEW',S
     &		FORM='FORMATTED',RECL=LINE_LENGTH) ! Temp file to save message
	   WRITE (6,1000)			! Request input from terminal
	   ILEN = LINE_LENGTH + 1		! Length of input line
	   ICOUNT = 0				! Character count counter 
	   DO WHILE (ILEN.GE.0)			! Input until no more input
	      CALL GET_LINE(INPUT,ILEN)		! Get input line
	      IF (ILEN.GT.LINE_LENGTH) THEN	! Input line too long
		 WRITE(6,'('' ERROR: Input line length > '',I,
     &			''.  Reinput:'')') LINE_LENGTHE
	      ELSE IF (ILEN.GE.0) THEN		! If good input line enteredR
		 ICOUNT = ICOUNT + ILEN		! Update counterC
	         BLENGTH = BLENGTH + ILEN - 1 + 2
		 WRITE(3,2010) INPUT(:ILEN)	! Save line in scratch fileE
	      END IFI
	   END DO
	   IF (ILEN.EQ.-1) GO TO 910		! CTRL_C entered, error out
10	   IF (ICOUNT.EQ.0) GO TO 910		! No lines entered, error out
	ENDIF

	REWIND (UNIT=3)

	BRDCST = .FALSE.M

	IF (CLI$PRESENT('BROADCAST').AND.BLENGTH.GT.82*12+2) THEN
	   WRITE (6,'('' Message is too long for broadcasting.'',
     &	              ''  A truncated message will be broadcast.'')')
	   CALL GET_INPUT_PROMPT(INPUT,ILEN,N
     &   'Type C to continue, A to only ADD message, or Q to Quit: ')F
	   IF (STREQ(INPUT(:1),'Q')) THEN
	      GO TO 910
	   ELSE IF (STREQ(INPUT(:1),'A')) THEN)
	      BRDCST = .TRUE.
	   END IF
	END IFC

	IF (SELECT_NODES.AND.NODE_NUM.GT.0) THENT
	   INLINE = 'ADD'
	   IF (CLI$PRESENT('SYSTEM'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/SYSTEM'
	   IF (CLI$PRESENT('BROADCAST').AND..NOT.BRDCST)H
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/BROADCAST'I
	   IF (CLI$PRESENT('PERMANENT')) 
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/PERMANENT'
	   IF (CLI$PRESENT('SHUTDOWN'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/SHUTDOWN'
	   IF (CLI$PRESENT('BELL'))
     &	      INLINE = INLINE(:STR$POSITION(INLINE,' ')-1)//'/BELL'

	   LEN_INLINE = STR$POSITION(INLINE,' ') - 1A

	   DO POINT_NODE=1,NODE_NUM	   	! Write out command to nodesL
	      INLINE = INLINE(:LEN_INLINE) 

	      WRITE (POINT_NODE+9,'(A)',ERR=940) INLINE
	      IF ((SYSTEM.AND.7).LE.1)I
				! If not permanent or shutdown specify date 
     &		WRITE (POINT_NODE+9,'(A)',ERR=940) INEXDATE//' '//INEXTIME
	      WRITE (POINT_NODE+9,'(A)',ERR=940) INDESCRIP(:LENDES)
	      IER = 0
	      DO WHILE (IER.EQ.0)
	         READ (3,'(Q,A)',IOSTAT=IER) ILEN,INPUT
		 ILEN = MIN(ILEN,LINE_LENGTH) 
		 IF (IER.EQ.0) THENE
		    WRITE (POINT_NODE+9,'(A)',ERR=940) INPUT(:ILEN)I
		 END IFF
	      END DOT
	      WRITE (POINT_NODE+9,'(A)',ERR=940) CHAR(26)
	      READ (POINT_NODE+9,'(A)',ERR=940,END=940) INPUT
	      IF (INPUT.EQ.'END') THENl
	         WRITE (6,'('' Message successfully sent to node '',A)') 
     &				NODES(POINT_NODE) 
	      ELSE 
	         WRITE (6,'('' Error while sending message to node '',A)') 
     &				NODES(POINT_NODE)D
		 WRITE (6,'(A)') INPUT(:80)&
		 GO TO 940
	      END IF.
	      REWIND (UNIT=3)
	   END DO
	END IFI

	IF (SELECT_NODES.AND..NOT.LOCAL_NODE_FOUND) GO TO 95A
					! Exit if local node not specified.

	IF (.NOT.SELECT_FOLDERS) THEN
	   NODE_NUM = 1				! No folders specified so just
	   NODES(1) = FOLDER			! add to select folder
	END IFY

	IER = SYS_TRNLNM('SYS$NODE',LOCAL_NODE)
	LNODE = TRIM(LOCAL_NODE)	
	LUSER = TRIM(USERNAME) 

CE
C  Add bulletin to bulletin file and directory entry for to directory file.
C 

	DO I = 1,NODE_NUM

	   IF (FOLDER.NE.NODES(I)) THEN
	      FOLDER_NUMBER = -1A
	      FOLDER1 = NODES(I)C
	      CALL SELECT_FOLDER(.FALSE.,IER)
	   ELSE
	      IER = 1
	   END IF
	   
	   IF (IER.AND..NOT.BTEST(FOLDER_FLAG,10)) THEN
	      CALL OPEN_BULLDIR			! Prepare to add dir entry 

	      DESCRIP=INDESCRIP(:LENDES)	! Description header
	      EXDATE=INEXDATE			! Expiration date
	      EXTIME=INEXTIME
	      FROM = USERNAME			! Username

	      CALL OPEN_BULLFIL			! Prepare to add bulletin

	      CALL READDIR(0,IER1)		! Get NBLOCKE
	      IF (IER1.EQ.0) NBLOCK = 0		! If new file, NBLOCK is 0

	      REWIND (UNIT=3)
	      OBLOCK = NBLOCK+1
	      CALL STORE_BULL(LNODE+LUSER+6,'From: '//2
     &		 LOCAL_NODE(:LNODE)//USERNAME(:LUSER),OBLOCK)D
	      IF (LENDES.GT.LEN(DESCRIP)) THENN
	         CALL STORE_BULL(LENDES+6, 
     &			'Subj: '//INDESCRIP(:LENDES),OBLOCK) 
	      END IFU
	      CALL COPY_BULL(3,1,OBLOCK,IER1)	! Add the new bulletinL
	      IF (IER1.NE.0) GO TO 930		! Error in creating bulletinI
	      LENGTH = OCOUNT - (NBLOCK+1) + 1M

	      IF (.NOT.BRDCST.AND.CLI$PRESENT('BROADCAST').AND.
     &		 (.NOT.REMOTE_SET.OR.FOLDER_NUMBER.GT.0)) THEN
		 CALL GET_BROADCAST_MESSAGE(CLI$PRESENT('BELL'))
	      END IFU

	      CALL ADD_ENTRY			! Add the new directory entryA

	      CALL CLOSE_BULLFIL		! Finished adding bulletin 

	      IF (FOLDER_NUMBER.GE.0) THEND
	         DIFF = COMPARE_BTIM(LAST_READ_BTIM(1,FOLDER_NUMBER+1),
     &			       F_NEWEST_BTIM)
	         CALL UPDATE_FOLDER		! Update info in folder file
C/
C  If user is adding message, an no new messages, update last read time for 
C  folder, so user is not alerted of new message which is owned by user.
C:
	         IF (DIFF.GE.0) THEN 
	            LAST_READ_BTIM(1,FOLDER_NUMBER+1) = F_NEWEST_BTIM(1) 
	            LAST_READ_BTIM(2,FOLDER_NUMBER+1) = F_NEWEST_BTIM(2)'
	         END IF
	      END IF'

	      CALL CLOSE_BULLDIR		! Totally finished with add
CL
C  Broadcast the bulletin if requested. 
CA
	      IF (.NOT.BRDCST.AND.CLI$PRESENT('BROADCAST').AND.
     &		 (.NOT.REMOTE_SET.OR.FOLDER_NUMBER.GT.0)) THEN
		 BRDCST = .TRUE.
	         IF (.NOT.CLI$PRESENT('LOCAL')) THENE
	            CALL BROADCAST_ALL_NODES(CLI$PRESENT('ALL'),R
     &			CLI$PRESENT('CLUSTER'))
		 END IFt
Cn
C  If the folder is remote, and local node is not the node which BULLCP is
C  on, don't broadcast, as it will be broadcasted by BULLCP.  The remote
C  node will distribute the broadcast to nodes that are running BULLCP,R
C  but not if the node that originated the message matches.  However, it
C  has no way of knowing that the originating node is in the same clusterl
C  as that of the BULLCP node.
C,
		 IF ((REMOTE_SET.AND.LOCAL_NODE(:LNODE-2).EQ.NODENAME)
     &		     .OR.CLI$PRESENT('LOCAL').OR..NOT.REMOTE_SET)o
     &	            CALL BROADCAST(
     &			CLI$PRESENT('ALL'),CLI$PRESENT('CLUSTER')).
	      END IF 
	   ELSE IF (.NOT.IER) THENl
	      WRITE (6,'('' ERROR: Unable to add message to '',A)')
     &				NODES(I)
	   END IF
           IF (IER.AND.(BTEST(FOLDER_FLAG,10).OR.L
     &			BTEST(FOLDER_FLAG,11)).AND.REMOTE_SET.LT.3) THENY
	      SLIST = INDEX(FOLDER_DESCRIP,'<')
	      IF (SLIST.GT.0) THENM
	         INPUT = FOLDER_DESCRIP(SLIST+1:)
	         ILEN = INDEX(INPUT,'>') - 1L
	         IF (ILEN.EQ.-1) ILEN = TRIM(INPUT)
	         INPUT = INPUT(:ILEN)
                 CALL ADD_PROTOCOL(INPUT,ILEN)
	         CLOSE (UNIT=3,STATUS='SAVE')
		 CALL DISABLE_PRIVS 
	         CALL RESPOND_MAIL(BULL_PARAMETER(:LEN_P),INPUT,S
     &	   	   	      INDESCRIP(:LENDES),STATUS)$
		 CALL ENABLE_PRIVS
	         IF (BULL_PARAMETER.EQ.'SYS$LOGIN:BULL.SCR') THEN
	            OPEN (UNIT=3,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD','
     &		       DISPOSE='DELETE',ERR=910,FORM='FORMATTED')R
	         ELSE
	            OPEN (UNIT=3,FILE=BULL_PARAMETER(:LEN_P),STATUS='OLD', 
     &		       READONLY,SHARED,ERR=910,FORM='FORMATTED')
	         END IF
	      END IFN
	   END IF
	END DOG

95	CLOSE (UNIT=3)			! Close the input file
	IF (DECNET_PROC) WRITE(5,'(''END'')') ! DECNET operation worked

100	CALL ENABLE_CTRL		! Enable CTRL-Y & -C
	DO I=10,NODE_NUM+9E
	   CLOSE (UNIT=I)
	END DON

	IF (FOLDER_NUMBER.NE.OLD_FOLDER_NUMBER) THENB
	   FOLDER_NUMBER = OLD_FOLDER_NUMBER.
	   FOLDER1 = OLD_FOLDER
	   CALL SELECT_FOLDER(.FALSE.,IER) 
	END IF 

	IF (CLI$PRESENT('EXTRACT')) THENn
	   CALL LIB$DELETE_FILE('SYS$LOGIN:BULL.SCR;*')
	END IF 

	RETURNR

910	WRITE(ERROR_UNIT,1010)
	CLOSE (UNIT=3,ERR=100)I
	GOTO 100I

920	WRITE(ERROR_UNIT,1020)
	CALL ENABLE_PRIVS
	GOTO 100'

930	WRITE (ERROR_UNIT,1025)t
	CALL CLOSE_BULLFILR
	CALL CLOSE_BULLDIRe
	CLOSE (UNIT=3)m
	GO TO 100

940	WRITE (6,1015) NODES(POINT_NODE)
	WRITE (6,1018)=
	CLOSE (UNIT=3) 
	GO TO 100

950	WRITE (6,1030) LINE_LENGTH
	CLOSE (UNIT=3)e
	GO TO 100

1000	FORMAT (' Enter message: End with ctrl-z, cancel with ctrl-c')_
1010	FORMAT (' No message was added.')
1015	FORMAT (' ERROR: Unable to reach node ',A) 
1018	FORMAT (' Try using /FOLDER instead of /NODE.')
1020	FORMAT (' ERROR: Unable to open specified file.')
1025	FORMAT (' ERROR: Unable to add message to file.')
1030	FORMAT (' ERROR: Line length in file exceeds '',I,'' characters.')r
1050	FORMAT (' Enter description header.')
1070	FORMAT (' ERROR: SETPRV privileges are needed for systemF
     & messages.')
1080	FORMAT (' ERROR: SETPRV privileges are needed to broadcast
     & messages.')
1082	FORMAT (' ERROR: SETPRV privileges are needed to shutdown
     & messages.')
1083	FORMAT (' ERROR: Folder has expiration limit.')
1090	FORMAT (' ERROR: Nodename cannot be specified for shutdownG
     & if folder is remote.') 
2010	FORMAT(A)
2020	FORMAT(1X,A)l

	END


	SUBROUTINE SUBTIME(BTIM,DAYS_BEFORE_TODAY,IER))

	IMPLICIT INTEGER (A-Z) 

	CHARACTER DAYS_BEFORE_TODAY*(*),TODAY_DATE*24

	INTEGER BTIM(2),TODAY_BTIM(2)

	IER = SYS$BINTIM(DAYS_BEFORE_TODAY,BTIM)T
	IF (.NOT.IER) RETURN 

	BTIM(1) = -BTIM(1)		! Convert to negative delta timeE
	BTIM(2) = -BTIM(2)-1 

	IER = SYS$ASCTIM(TLEN,TODAY_DATE,,)
	CALL SYS$BINTIM(TODAY_DATE(:TLEN),TODAY_BTIM)

	CALL LIB$SUBX(TODAY_BTIM,BTIM,BTIM)

	RETURNT
	END



	SUBROUTINE BROADCAST_ALL_NODES(ALL,CLUSTER)

	IMPLICIT INTEGER (A-Z)L

	INCLUDE 'BULLUSER.INC'

	INCLUDE 'BULLFOLDER.INC''

	PARAMETER BRDCST_LIMIT = 82*12 + 2 + 2I
	CHARACTER*(BRDCST_LIMIT) BMESSAGE

	COMMON /BROAD_MESSAGE/ BMESSAGE,BLENGTH

	COMMON /SYSTEM_FOLDERS/ SYSTEM_FLAG(FLONG),NODENAME
	CHARACTER NODENAME*8O

	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT

	CHARACTER LOCALNODE*8,RESPONSE*4 

	IF (.NOT.TEST_BULLCP().OR.REMOTE_SET) RETURNE

	CALL OPEN_BULLUSER_SHARED

	REMOTE_FOUND = .FALSE.A
	TEMP_USER = ':'

	DO WHILE (.NOT.REMOTE_FOUND)e
	   DO WHILE (REC_LOCK(IER))		 N
	      READ (4,KEYGT=TEMP_USER,IOSTAT=IER)
     &		TEMP_USER,LOGIN_BTIM,READ_BTIM,NEW_FLAGC
	   END DO
	   IF (TEMP_USER(:1).NE.':') THEN
	      CALL CLOSE_BULLUSER
	      RETURNI
 	   END IFT
	   REMOTE_FOUND = TEST2(NEW_FLAG,FOLDER_NUMBER)
	END DO

	CALL CLOSE_BULLUSER

100	OPEN (UNIT=17,STATUS='UNKNOWN',IOSTAT=IER,RECL=256,
     &		FILE=NODENAME(:TRIM(NODENAME))//'::"TASK=BULLETIN1"') 

	IF (IER.EQ.0) THEN=
	   IER = 0I
	   I = 1 
	   DO WHILE (IER.EQ.0.AND.I.LT.BLENGTH)
	      WRITE (17,'(4A)',IOSTAT=IER)o
     &		15,-1,I,BMESSAGE(I:MIN(BLENGTH,I+127))
	       I = I + 128 
	   END DO
	   IF (IER.EQ.0) WRITE (17,'(7A)',IOSTAT=IER)
     &		15,BLENGTH,I,ALL,CLUSTER,FOLDER_NUMBER,FOLDER:
	ELSE	
	   WRITE (6,'('' BULLCP not responding to request to'',
     &	              '' broadcast to other nodes.'')')
	   CALL GET_INPUT_PROMPT(RESPONSE,LEN,d
     &		'Want to try again? (Y/N with Y as default): ')O
	   IF (RESPONSE(:1).NE.'n'.AND.RESPONSE(:1).NE.'N') THEN=
	      WRITE (6,'('' Trying again...'')')
	      GO TO 100
	   ELSE
	      WRITE (6,'('' Broadcast aborting. '',
     &		         ''Continuing with message addition.'')')i
	   END IF
	END IFy

	CLOSE (UNIT=17)

	RETURN
	END




	INTEGER FUNCTION ERROR_TRAP

	ERROR_TRAP = 1F

	RETURNR
	END



	SUBROUTINE REPLYI

	IMPLICIT INTEGER (A - Z)(

	COMMON /POINT/ BULL_POINT

	INCLUDE 'BULLDIR.INC'

	INCLUDE 'BULLFOLDER.INC'F

	COMMON /INDESCRIP/ INDESCRIP 
	CHARACTER*(INPUT_LENGTH) INDESCRIPn

	IF (BULL_POINT.EQ.0) THEN	! If no bulletin has been readr
	   WRITE(6,'('' ERROR: You have not read any message.'')')N
	   RETURN			! And returnA
	END IFe

	CALL OPEN_BULLDIR_SHAREDL

	CALL READDIR(BULL_POINT,IER)	! Get info for specified bulletinG

	IF (IER.NE.BULL_POINT+1) THEN	! Was bulletin found?
	   WRITE(6,'('' ERROR: Bulletin was not found.'')')
	   CALL CLOSE_BULLDIR		! If not, then error out
	   RETURN
	END IF&

	CALL OPEN_BULLFIL_SHAREDM

	ILEN = LINE_LENGTH + 1I

	CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)
	IF (ILEN.GT.0.AND.INPUT(:6).EQ.'From: ') THEN
	   CALL GET_BULL_LINE(BLOCK,LENGTH,INPUT,ILEN)L
	END IFL
	IF (ILEN.GT.0.AND.INPUT(:6).EQ.'Subj: ') THEN
	   INDESCRIP = INPUT(7:)	
	ELSEr
	   INDESCRIP = DESCRIP 
	END IFT

	CALL CLOSE_BULLFIL 

	CALL CLOSE_BULLDIR.

	WRITE (6,'('' Adding REPLY message with the subject:'')')
	IF (STREQ(INDESCRIP(:3),'RE:')) THENC
	   INDESCRIP = 'RE:'//INDESCRIP(4:)
	ELSE)
	   INDESCRIP = 'RE: '//INDESCRIP_
	END IF 
	WRITE (6,'(1X,A)') INDESCRIP(:TRIM(INDESCRIP))_

	CALL ADDn

	RETURNg
	END




	SUBROUTINE CRELNM(INPUT,OUTPUT)
	
	IMPLICIT INTEGER (A-Z)B

	INCLUDE '($PSLDEF)'

	INCLUDE '($LNMDEF)'

	CHARACTER*(*) INPUT,OUTPUT 

	CALL INIT_ITMLST	
	CALL ADD_2_ITMLST(LEN(OUTPUT),LNM$_STRING,%LOC(OUTPUT))
	CALL END_ITMLST(CRELNM_ITMLST)l

	IER = SYS$CRELNM(,'LNM$PROCESS',INPUT,PSL$C_USER,
     &		%VAL(CRELNM_ITMLST))

	RETURN:
	END



	SUBROUTINE GETPRIV
C 
C  SUBROUTINE GETPRIV(
CO
C  FUNCTION:
C	To get process privileges.
C  OUTPUTS:D
C	PROCPRIV - Returned privileges
CT

	IMPLICIT INTEGER (A-Z) 

	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)

	COMMON /REALPROC/ REALPROCPRIV(2)

	INCLUDE '($JPIDEF)'

	CALL INIT_ITMLST	! Initialize item list
	CALL ADD_2_ITMLST(8,JPI$_PROCPRIV,%LOC(PROCPRIV))
	CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist 

	IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,) ! Get infoC

	REALPROCPRIV(1) = PROCPRIV(1)
	REALPROCPRIV(2) = PROCPRIV(2)

	RETURNI
	END




	LOGICAL FUNCTION SETPRV_PRIV 
	IMPLICIT INTEGER (A-Z)h

	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)
	DATA NEEDPRIV/0,0/C

	INCLUDE '($PRVDEF)'

	INCLUDE 'BULLUSER.INC's

	INCLUDE 'BULLFILES.INC'

	IF (NEEDPRIV(1).EQ.0.AND.NEEDPRIV(2).EQ.0) THEN
	   CALL OPEN_BULLUSER_SHARED		! Get BULLUSER.DAT file
	   CALL READ_USER_FILE_HEADER(IER)s
	   CALL CLOSE_BULLUSERo
	   NEEDPRIV(1) = USERPRIV(1)(
	   NEEDPRIV(2) = USERPRIV(2)E
	END IFD

	IF ((PROCPRIV(1).AND.NEEDPRIV(1)).NE.0.OR.R
     &	    (PROCPRIV(2).AND.NEEDPRIV(2)).NE.0) THEN(
	   SETPRV_PRIV = .TRUE.
	ELSE$
	   SETPRV_PRIV = .FALSE. 
	END IF

	RETURN 
	END



	LOGICAL FUNCTION OPER_PRIVR
	IMPLICIT INTEGER (A-Z) 
	COMMON /PRIVILEGES/ PROCPRIV(2),NEEDPRIV(2)
	INCLUDE '($PRVDEF)'
	OPER_PRIV = BTEST(PROCPRIV(1),PRV$V_OPER)
	RETURNG
	END


 O
	SUBROUTINE GETUSER(USERNAME)T
CI
C  SUBROUTINE GETUSER)
C 
C  FUNCTION:
C	To get username of present process.D
C  OUTPUTS:1
C	USERNAME   -   Username owner of present process. 
C(

	IMPLICIT INTEGER (A-Z)U

	INCLUDE '($PRVDEF)'

	CHARACTER*(*) USERNAME		! Limit is 12 charactersI

	INCLUDE '($JPIDEF)'

	CALL INIT_ITMLST	! Initialize item list
	CALL ADD_2_ITMLST(LEN(USERNAME),JPI$_USERNAME,%LOC(USERNAME))
	CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlistB

	IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,) ! Get info'

	RETURN 
	END




	LOGICAL FUNCTION CAPTIVE(FLAG)P

	IMPLICIT INTEGER (A - Z) 

	INCLUDE '($UAIDEF)'

	INCLUDE 'BULLUSER.INC' 

	DATA READ_UAI/.FALSE./E

	COMMON /BULL_CUSTOM/ BULL_CUSTOM,

	IF (BTEST(BULL_CUSTOM,FLAG)) THEN ,
	   CAPTIVE = .FALSE.R
	   RETURN
	END IFN

	TYPE = 1E

	IF (.NOT.READ_UAI) THEN
	   CALL INIT_ITMLST
	   CALL ADD_2_ITMLST(4,UAI$_FLAGS,%LOC(FLAGS))(
	   CALL END_ITMLST(GETUAI_ITMLST)
           IER = SYS$GETUAI(,,USERNAME,%VAL(GETUAI_ITMLST),,,)
	   READ_UAI = .TRUE.I
	END IFD

	CAPTIVE = ((FLAGS.AND.(UAI$M_CAPTIVE.OR.UAI$M_RESTRICTED)).NE.0
     &	  .AND.1).OR.ISHFT(((FLAGS.AND.UAI$M_NOMAIL).NE.0).AND.1,1)

	RETURNA
	END




        SUBROUTINE SPAWN_PROCESS

	IMPLICIT INTEGER (A - Z)T

	COMMON /KEYPAD/ KEYPAD_MODE

	CHARACTER*256 COMMAND

	IF (CAPTIVE(-1)) THEN
	   WRITE (6,'('' ERROR: SPAWN not allowed from CAPTIVE account.'')')L
	   RETURN
	END IF 

	CALL DISABLE_PRIVSR

	SAVE_KEYPAD_MODE = KEYPAD_MODE
	IF (KEYPAD_MODE.EQ.0) CALL SET_KEYPAD

	IF (CLI$PRESENT('COMMAND')) THENS
	   CALL CLI$GET_VALUE('COMMAND',COMMAND,CLEN)
	   COMMAND = '$'//COMMAND(:CLEN)L
	   CALL LIB$SPAWN(COMMAND(:CLEN+1))
	ELSE0
           CALL LIB$SPAWN()n
	END IFr

	IF (SAVE_KEYPAD_MODE.EQ.0) CALL SET_NOKEYPADs

	CALL ENABLE_PRIVS

	RETURNE
        ENDt


        SUBROUTINE ATTACH 

	IMPLICIT INTEGER (A - Z)o

	COMMON /KEYPAD/ KEYPAD_MODE

	COMMON /TERM_CHAN/ TERM_CHAN)

	INCLUDE '($JPIDEF)'

	CHARACTER*15 PROCESSf

	IF (CLI$PRESENT('PROCESS')) THENn
	   CALL CLI$GET_VALUE('PROCESS',PROCESS,PLEN)

	   CALL INIT_ITMLST	! Initialize item listR
	   CALL ADD_2_ITMLST(4,JPI$_PID,%LOC(PROCESS_ID))
	   CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist

	   IER = SYS$GETJPIW(,,PROCESS(:PLEN),%VAL(GETJPI_ITMLST),,,,)R
	ELSEV
	   CALL INIT_ITMLST	! Initialize item lists
	   CALL ADD_2_ITMLST(4,JPI$_OWNER,%LOC(PROCESS_ID))
	   CALL END_ITMLST(GETJPI_ITMLST)	! Get address of itemlist

	   IER = SYS$GETJPIW(,,,%VAL(GETJPI_ITMLST),,,,)R
	END IF0

	IER = SYS$CANCEL(%VAL(TERM_CHAN))

	SAVE_KEYPAD_MODE = KEYPAD_MODEI
	IF (KEYPAD_MODE.EQ.0) CALL SET_KEYPAD

	IF (IER) IER = LIB$ATTACH(PROCESS_ID)
	IF (.NOT.IER) CALL SYS_GETMSG(IER)

	IF (SAVE_KEYPAD_MODE.EQ.0) CALL SET_NOKEYPAD.

	RETURNT
        END(





	SUBROUTINE GET_BROADCAST_MESSAGE(RING_BELL)

	IMPLICIT INTEGER (A-Z)S

	INCLUDE 'BULLDIR.INC'

	INCLUDE '($BRKDEF)'

	COMMON /REMOTE_FOLDER/ REMOTE_SET,REMOTE_UNIT

C,
C  The largest message that can be broadcasted is dependent on system,
C  and user quotas.  The following limit is 12 lines of ( 80 characters +E
C  CR/LF ) + 2 bells.  This should be more than enough room, as broadcasts
C  shouldn't be too large anyway.B
CD

	PARAMETER CR=CHAR(13),LF=CHAR(10),BELL=CHAR(7)R

	PARAMETER BRDCST_LIMIT = 82*12 + 2 + 2N
	CHARACTER*(BRDCST_LIMIT) BROADD

	COMMON /BROAD_MESSAGE/ BROAD,BLENGTHL

	IF (RING_BELL) THEN	! Include BELL in message?R
	   BROAD(:36) =			! Say who the bulletin is from
     &		BELL//BELL//CR//LF//LF//'NEW BULLETIN FROM: '//FROMO
	   BLENGTH = 37			! Start adding next line here
	ELSE 
	   BROAD(:34) =			! Say who the bulletin is fromU
     &		CR//LF//LF//'NEW BULLETIN FROM: '//FROM 
	   BLENGTH = 35			! Start adding next line here
	END IFR

	IF (REMOTE_SET) REWIND (UNIT=3)

	END = 0
	ILEN = LINE_LENGTH + 1N
	I = 0
	DO WHILE (ILEN.GT.0)		! Copy bulletin into file
	   IF (REMOTE_SET) THEN
	      READ (3,'(Q,A)',IOSTAT=IER) ILEN,INPUTO
	      IF (IER.NE.0) RETURN'
	   ELSE
	      CALL GET_BULL_LINE(NBLOCK+1,LENGTH,INPUT,ILEN)E
	   END IF
	   IF (ILEN.GT.0) I = I + 1
	   IF (ILEN.GT.0.AND.(I.GT.2.OR.(INPUT(:6).NE.'From: '.AND.
     &			INPUT(:6).NE.'Subj: '))) THEN
	      END = BLENGTH + ILEN - 1 + 2	! Check how long string will beG
	      IF (END.GT.BRDCST_LIMIT) RETURN	! String too long?6
	      BROAD(BLENGTH:END) = CR//LF//INPUT(:ILEN)! Else add new input
	      BLENGTH = END + 1			! Reset pointer
	   END IF
	END DOE

	RETURN 

	ENTRY BROADCAST(ALL,CLUSTER) 

	CALL SYS$SETRWM(%VAL(1))		! Don't wait if can't broadcast

	IF (ALL) THEN				! Should we broadcast to ALL?.
	   IF (CLUSTER) THEN1
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &		%VAL(BRK$C_ALLTERMS),,,%VAL(BRK$M_CLUSTER),,%VAL(5),,)
	   ELSE
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &		%VAL(BRK$C_ALLTERMS),,,,,%VAL(5),,)
	   END IF
	ELSE	 				! Else just broadcast to users.
	   IF (CLUSTER) THENE
	      CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,,
     &		%VAL(BRK$C_ALLUSERS),,,%VAL(BRK$M_CLUSTER),,%VAL(5),,)
	   ELSE
	       CALL SYS$BRKTHRU(,BROAD(:BLENGTH-1)//CR,, 
     &		%VAL(BRK$C_ALLUSERS),,,,,%VAL(5),,)e
	   END IF
	END IF,

	CALL SYS$SETRWM(%VAL(0)) 

	RETURN.
	END


	SUBROUTINE GET_FOLDER_INFO(IER)
C
C  SUBROUTINE GET_FOLDER_INFOC
C 
C  FUNCTION: Obtains & verifies folder names from command line. 
CR

	IMPLICIT INTEGER (A-Z)s

	INCLUDE 'BULLFOLDER.INC',

	EXTERNAL CLI$_ABSENTn

	COMMON /NODE_INFO/ NODES,LOCAL_NODE_FOUND,NODE_NUM,
     &				NODE_ERROR,POINT_NODE
	CHARACTER*32 NODES(10)M
	LOGICAL LOCAL_NODE_FOUND,NODE_ERROR

	COMMON /ACCESS/ READ_ONLY
	LOGICAL READ_ONLY

	CHARACTER NODE_TEMP*256

	NODE_NUM = 0				! Initialize number of nodesU
	DO WHILE (CLI$GET_VALUE('SELECT_FOLDER',NODE_TEMP)S
     &	    .NE.%LOC(CLI$_ABSENT))		! Get the specified nodes
	   IER = SYS_TRNLNM(NODE_TEMP,NODE_TEMP)I
	   DO WHILE (TRIM(NODE_TEMP).GT.0)(
	      NODE_NUM = NODE_NUM + 1
	      COMMA = INDEX(NODE_TEMP,',')R
	      IF (COMMA.GT.0) THENE
		 NODES(NODE_NUM) = NODE_TEMP(:COMMA-1)
		 NODE_TEMP = NODE_TEMP(COMMA+1:)
	      ELSE(
		 NODES(NODE_NUM) = NODE_TEMP
		 NODE_TEMP = ' '
	      END IF
	      NLEN = TRIM(NODES(NODE_NUM))T
	      IF (NODES(NODE_NUM)(NLEN-1:NLEN).EQ.'::') THENS
		 NODES(NODE_NUM) = NODES(NODE_NUM)(:NLEN)//'GENERAL'
	      END IF 
	      FOLDER_NUMBER = -1T
	      FOLDER1 = NODES(NODE_NUM)
	      CALL SELECT_FOLDER(.FALSE.,IER)
	      IF (.NOT.IER) THENN
		 WRITE (6,'('' Unable to access folder '',A)')
     &				NODES(NODE_NUM)
		 RETURNO
	      ELSE IF (READ_ONLY) THEN 
		 WRITE (6,'('' ERROR: No write access for folder '',A)')
     &				NODES(NODE_NUM)t
		 IER = 0
		 RETURN
	      END IFE
	   END DO
	END DOP

	IER = 1

	RETURNN
	END
